
#load("/home/sgg4/ruby_ws/gene_sets/SeqExtractor.rb")
#load("/home/sgg4/ruby_ws/gene_sets/SeqExtractor.rb")
load("SeqExtractor.rb")

class ChipSeqDataset
  
  attr_accessor :id, :dataset_seq_regions, :params, :known_consensus, :total_num_regions,:dataset_specific_parameters
  attr_writer :known_consensus
  
  def initialize_from_FASTA_input(fasta_file)
    @dataset_seq_regions = read_seq_and_scores_FASTA_format(seq_file)
#    @dataset_seq_regions.sort{|a,b| (a.start <=> b.start) and (a.chr.to_i <=> b.chr.to_i)}.reverse!
#    sort_descending_by_score()
  end
  
  def initialize_from_cERMIT_input(peaks_file)
#    @dataset_seq_regions = read_seq_and_scores_cERMIT_format(seq_file, scores_file)
    @dataset_seq_regions = read_seq_and_scores_cERMIT_format(peaks_file)
#    @dataset_seq_regions.sort{|a,b| (a.start <=> b.start) and (a.chr.to_i <=> b.chr.to_i)}.reverse!
#    sort_descending_by_score()
  end
  
  def construct_peaks_file_name(global_params, dataset_specific_parameters)
#    print global_params["peaks_file_path"],"\n", global_params["species"], "\n",dataset_specific_parameters["dataset_id"], "\n"
    @dataset_specific_parameters["peaks_file"] = global_params["peaks_file_path"]+global_params["species"]+"/"+dataset_specific_parameters["dataset_id"]+"_"+"score.out"
  end
  
  def construct_known_pssm_file_name(global_params, dataset_specific_parameters)
#    dataset_specific_parameters["peaks_file"] = global_params["peaks_file_path"]+global_params["species"]+"/"+dataset_specific_parameters["dataset_id"]+"/"+"score.out"
    if(global_params["known_pssm_path"] != nil)
	known_pssm_file = global_params["known_pssm_path"] + "pssm_" + dataset_specific_parameters["dataset_id"]
#     	print "known_pssm_file: ", known_pssm_file,"\n"
#    	$stdin.gets
	@dataset_specific_parameters["known_pssm_file"] = known_pssm_file
    else
	@dataset_specific_parameters["known_pssm_file"] = ""
    end
  end

  def construct_known_consensus(dataset_specific_parameters)
    known_consensus = dataset_specific_parameters["known_consensus"] 
    @dataset_specific_parameters["known_consensus"] = known_consensus
  end
    
# possible inputs:
#-----------------
# args = [seq_file, scores_file, min_length, max_length, min_score, max_score, known_consensus, dataset_id] -> length = 7
# args = [FASTA_file, min_length, max_length, min_score, max_score, known_consensus, dataset_id]            -> length = 6
# args = [seq_regions, known_consensus, dataset_id]                                                         -> length = 2
  def initialize(global_params, dataset_specific_parameters)
    if(dataset_specific_parameters["dataset_id"]) == nil
      return nil
    end

    @dataset_specific_parameters = dataset_specific_parameters
#    print "@dataset_specific_parameters = ", @dataset_specific_parameters.inspect, "\n"
#    $stdin.gets

    # initialize with array of regions
    if(dataset_specific_parameters["regions_arr_initialization"] == true)
      @dataset_seq_regions         = dataset_specific_parameters["regions_arr"]
      @known_consensus             = dataset_specific_parameters["known_consensus"]
 #         @id = dataset_specific_parameters["dataset_id"]
      return
    end
    
#    @id = dataset_specific_parameters["dataset_id"]
    
    construct_peaks_file_name(global_params, dataset_specific_parameters)
    construct_known_pssm_file_name(global_params, dataset_specific_parameters)
    construct_known_consensus(dataset_specific_parameters)

    initialize_from_cERMIT_input(dataset_specific_parameters["peaks_file"])
    preprocess_data(global_params)  
#    elsif(args.length == 6)
#      seq_file = args[0]
#      initialize_from_FASTA_input(seq_file)
#      preprocess_data(args[1..-1])  
#    elsif(args.length == 2)
##      print "needs to change: @dataset_seq_regions is not ARRAY but HASH\n"
##      gets
#      @dataset_seq_regions = args[0]
#      @known_consensus     = args[1]
#    else
#      print "ERROR: args.length = ", args.length
#      gets
#    end
    update_total_num_regions()
#    print @id,":\t", @dataset_seq_regions.length, "\n"
  end

 
  
#  def initialize_old(*args)
#    @id = args.last
#    args.pop()
#    if(args.length == 7)
#      seq_file    = args[0]
#      scores_file = args[1]
##      initialize_from_cERMIT_input(seq_file, scores_file)
#      initialize_from_cERMIT_input(scores_file)
#      preprocess_data(args[2..-1])  
#    elsif(args.length == 6)
#      seq_file = args[0]
#      initialize_from_FASTA_input(seq_file)
#      preprocess_data(args[1..-1])  
#    elsif(args.length == 2)
##      print "needs to change: @dataset_seq_regions is not ARRAY but HASH\n"
##      gets
#      @dataset_seq_regions = args[0]
#      @known_consensus     = args[1]
#    else
#      print "ERROR: args.length = ", args.length
#      gets
#    end
#    update_total_num_regions()
##    print @id,":\t", @dataset_seq_regions.length, "\n"
#  end
      
  def preprocess_data(global_params)
#    species         = global_params["species"]
#    dataset_id      = dataset_specific_parameters["dataset_id"]
#    known_consensus = dataset_specific_parameters["known_consensus"]
#    min_length, max_length, min_score, max_score, @known_consensus, @known_pssm_file = args[0][0..-1]
#    dataset_specific_parameters = @dataset_specific_parameters

    @num_above_max = 0
    @num_below_min = 0
    @ave_above_max = 0
    @ave_below_min = 0
    
#    file = "/nfs/labs/compbio/ohler/pubs/Georgiev08/cERMIT/Jan_2009/peak_lengths_"+@id
#    f_out = ""
#    write_to_file_flag = false
#    if(FileTest.exist?(file) == false)
#      write_to_file_flag = true
#      f_out = File.open(file, "w")
#    end
    @seq_length_filter = lambda do |seq_region, global_params|
    
      if(seq_region.start > seq_region.stop)
        print "ERROR: start > stop: seq_region.start=", seq_region.start,"\tseq_region.start=", seq_region.stop,"\n"
        seq_region.show()
	
	# jump has not been carefully debugged...
	next
      end
#      if(write_to_file_flag = true)
#        f_out.write(seq_region.seq_length.to_s+"\n")
#      end
#      bp_to_extract_on_each_side = @params["max_seq_length"] / 2
#      region = extract_flanking_the_peak_location(seq_region, bp_to_extract_on_each_side)
#      return region
      if(seq_region.seq_length >= global_params["min_seq_length"].to_i and seq_region.seq_length <= global_params["max_seq_length"].to_i)
        return seq_region
      end

      if(seq_region.seq_length > global_params["max_seq_length"].to_i)
        @num_above_max += 1
        @ave_above_max += seq_region.seq_length
#        print "seq_length= ", seq_region.seq_length, "\tchr",seq_region.chr, "\tstart=",seq_region.start,"\tstop=", seq_region.stop,"\n"
        bp_to_shrink      = seq_region.seq_length - global_params["max_seq_length"].to_i
        x                 = (seq_region.peak_location - seq_region.start).to_f
        y                 = (seq_region.stop          - seq_region.peak_location).to_f
        shrink_from_start = ((x / (x + y)) * bp_to_shrink).floor
        shrink_from_stop  = ((y / (x + y)) * bp_to_shrink).floor
        new_chr_start     = seq_region.start + shrink_from_start
        new_chr_stop      = seq_region.stop  - shrink_from_stop
        seq_region.set_id_and_location_info(seq_region.chr, new_chr_start, new_chr_stop)
        return seq_region
      end

      if(seq_region.seq_length < global_params["min_seq_length"].to_i)
        @num_below_min += 1
        @ave_below_min += seq_region.seq_length

        bp_to_extend      = global_params["min_seq_length"].to_i - seq_region.seq_length
#        print "seq_region.peak_location = ", seq_region.peak_location, "\n"
        
        x                 = (seq_region.peak_location - seq_region.start).to_f
        y                 = (seq_region.stop          - seq_region.peak_location).to_f
#        print "bp_to_extend = ", bp_to_extend, "\tx=", x, "\ty=",y, "\n"
        extend_from_start = 0
        extend_from_stop  = 0
        if(x == 0 and y == 0)
          extend_from_start = bp_to_extend / 2
          extend_from_stop  = bp_to_extend / 2
        else
          extend_from_start = ((x / (x + y)) * bp_to_extend).ceil
          extend_from_stop  = ((y / (x + y)) * bp_to_extend).ceil
        end
        new_chr_start     = seq_region.start - extend_from_start
        new_chr_stop      = seq_region.stop  + extend_from_stop
#        print "seq_length= ", seq_region.seq_length, "\tchr",seq_region.chr, "\tstart=",seq_region.start,"\tstop=", seq_region.stop,"\t"
#        print "bp_to_extend = ", bp_to_extend, "\n", "seq_region.peak_location = ", seq_region.peak_location, "\n"
        seq_region.set_id_and_location_info(seq_region.chr, new_chr_start, new_chr_stop)   
#        print "seq_length= ", seq_region.seq_length, "\tchr",seq_region.chr, "\tstart=",seq_region.start,"\tstop=", seq_region.stop,"\n"
        return seq_region
      end
    end
  
    @score_filter = lambda do |seq_region, global_params|
 #     if(seq_region.score >= global_params["region_min_score"].to_f and seq_region.score <= global_params["region_max_score"].to_f)
      if(seq_region.score >= -1000 and seq_region.score <= global_params["region_max_score"].to_f)
         return seq_region
      else
        return nil  
      end
    end
  
#    @seq_N_filter = lambda do |seq_region|
#      if(seq_region.seq.scan('N') != [])
#        count = 0
#        total_count = 0
#        seq_region.seq.each do |e|
#          if(e == 'N')
#            count += 1
#          end
#          total_count +=1
#        end
#        if(count > total_count / 2)
#          return nil
#        else
#          return seq_region
#        end
#      else
#        return seq_region
#      end
#    end    

#    print "@id = ", @id,"\n"
#    print "@dataset_seq_regions.length = ", @dataset_seq_regions.length
#    gets

#    k.each do |chr|
##      print chr, "\n"
#      @dataset_seq_regions[chr].sort!{|a,b| (a.start <=> b.start)}
##      @dataset_seq_regions[chr].each do |r|
##        r.show()
##      end
##      gets
#    end
    
#    print @dataset_specific_parameters["dataset_id"],"\n"

#    print "applying score filter\n"
    num_before = 0
    num_after  = 0 
    k = @dataset_seq_regions.keys.sort{|a,b| a.to_i<=>b.to_i}
    k.each do |chr|
#      print "chr",chr,"\n"
      num_before += @dataset_seq_regions[chr].length
      ChipSeqDataset.apply_filter(@score_filter, @dataset_seq_regions[chr], global_params)
      ChipSeqDataset.apply_filter(@seq_length_filter, @dataset_seq_regions[chr], global_params)
      ChipSeqDataset.merge_overlapping_regions(@dataset_seq_regions[chr])
#      ChipSeqDataset.sort_descending_by_score(@dataset_seq_regions[chr])
      num_after += @dataset_seq_regions[chr].length
    end
    update_total_num_regions()
      
#    print "num_before = ", num_before, "\n"
#    print "num_after = ", num_after, "\n"
    
#    ChipSeqDataset.merge_overlapping_regions(@dataset_seq_regions, global_params["min_seq_length"])

#    print "applying seq filter\n"
#    apply_filter(@seq_length_filter)
#    if(write_to_file_flag = true)
#      f_out.close()
#    end    
    
    @ave_below_min = @ave_below_min.to_f / @num_below_min
    @ave_above_max = @ave_above_max.to_f / @num_above_max
#    print "num_above_max = ", @num_above_max,"\nave_above_max = ", @ave_above_max,"\n"
#    print "num_below_min = ", @num_below_min,"\nave_below_min = ", @ave_below_min,"\n"


#    gets
#    num_to_remove = 30000
#    remove_bottom_scoring_fixed_threshold(num_to_remove)
#    gets
#    print "applying N filter\n"
#    apply_filter(@seq_N_filter)
#    print "length = ", @dataset_seq_regions.length,"\n"
#    gets
#    @dataset_seq_regions.sort{|a,b| (a.start <=> b.start) and (a.chr.to_i <=> b.chr.to_i)}.reverse!


#    @dataset_seq_regions.each do |chr, r_arr|
#    
#      @dataset_seq_regions.sort{|a,b| (a.start <=> b.start) and (a.chr.to_i <=> b.chr.to_i)}.reverse!
#      print chr, "\n"
#      r_arr.each do |r|
#        r.show()
#      end
#      gets
#    end

#    ChipSeqDataset.merge_overlapping_regions(@dataset_seq_regions, global_params["min_seq_length"])

#    print "@dataset_seq_regions.length = ", @dataset_seq_regions.length
#    gets
#    ChipSeqDataset.merge_overlapping_regions(@dataset_seq_regions, global_params["min_seq_length"])
#    print "observed_max_seq_length = ", @observed_max_seq_length, "\n"
#    apply_log_transform()
#    toggle_sign()

   # sort_descending_by_score()

#    @dataset_seq_regions.each do |r|
#      print r.score
#      gets
#    end
#    print "filtering done\n"
#   # "@known_consensus ", @known_consensus
#    gets
  end
   
#  def extract_flanking_the_peak_location(seq_region, bp_to_extract_on_each_side)
##    bp_to_the_left_of_the_peak  = [seq_region.peak_location - seq_region.start, bp_to_extract_on_each_side].max
##    bp_to_the_right_of_the_peak = [seq_region.stop - seq_region.peak_location, bp_to_extract_on_each_side].max
##    new_chr_start = seq_region.peak_location - bp_to_the_left_of_the_peak
##    new_chr_stop  = seq_region.peak_location + bp_to_the_right_of_the_peak
#
#    new_chr_start = seq_region.peak_location - bp_to_extract_on_each_side
#    new_chr_stop  = seq_region.peak_location + bp_to_extract_on_each_side
#    
##    new_chr_start = [seq_region.start, seq_region.peak_location - @params["max_seq_length"] / 2].max
##    new_chr_stop  = [seq_region.stop,  seq_region.peak_location + @params["max_seq_length"] / 2].min
###    offset_from_start = new_chr_start   - seq_region.start
###    offset_from_stop  = seq_region.stop - new_chr_stop
###    new_seq           = seq_region.seq.slice(offset_from_start...(seq_region.seq_length - offset_from_stop))
###    seq_region.seq    = new_seq
#    seq_region.set_id_and_location_info(seq_region.chr, new_chr_start, new_chr_stop)
#    return seq_region
#  end
  
  def append_50bp_on_both_ends_of_sequence(seq_region)
    chr   = seq_region.chr
    start = seq_region.start - 50
    stop  = seq_region.stop  + 50
    seq_region.set_id_and_location_info(chr, start, stop)
    return seq_region
  end
  
#  def extract_middle(seq_region)
#    seq_length     = seq_region.seq_length
#    offset         = (seq_length - @params["max_seq_length"]) / 2
##    new_seq        = seq_region.seq.slice(offset...(seq_length - offset))
##    seq_region.seq = new_seq
#    new_chr_start  = seq_region.start + offset
#    new_chr_stop   = seq_region.stop  - offset
#    seq_region.set_id_and_location_info(seq_region.chr, new_chr_start, new_chr_stop)
#    return seq_region
#  end
  
public
  
  def ChipSeqDataset.merge_overlapping_regions(regions_arr)
    regions_arr.sort!{|a,b| a.start <=> b.start}
    c=0;c1=0;c_short=0
    (0...(regions_arr.length-1)).each do |i|
#      if(regions_arr[i].get_length() < min_seq_length)
#        print i,"\t"
#        regions_arr[i].show()    
#        c_short += 1
#        gets
#      end

      start1        = regions_arr[i].start
      stop1         = regions_arr[i].stop
      start2        = regions_arr[i+1].start
      stop2         = regions_arr[i+1].stop
      res_intersect = SeqExtractor.get_intersection(start1, stop1, start2, stop2)
      if(res_intersect != nil)
        overlap_length  = res_intersect[1] - res_intersect[0]
        inter_peak_distance = (regions_arr[i].peak_location - regions_arr[i+1].peak_location).abs
        len1 = regions_arr[i+1].get_length()
        len2 = regions_arr[i].get_length()
        minimal_overlap = [len1,len2].min / 1.0
        if(true)#overlap_length >= minimal_overlap)# or overlap_length >= min_seq_length)
#        if(overlap_length >= minimal_overlap and inter_peak_distance <= overlap_length)
#        if(inter_peak_distance <= overlap_length)
          chr         = regions_arr[i].chr
          score1      = regions_arr[i].score
          score2      = regions_arr[i+1].score
          new_score   = [score1, score2].min#[score1, score2].max#(score1 + score2) / 2.0#
          if(new_score > 0)
            if(len1 > len2)
              new_score = score1
            elsif(len1 < len2)
              new_score = score2
            else
              new_score = [score1, score2].max  
            end
          else
            if(score1 > 0)
              new_score = score1  
            else
              new_score = score2
            end
          end
#          new_score   = (score1 + score2) / 2.0
         
          union       = SeqExtractor.get_union(start1, stop1, start2, stop2)
          start       = union[0]
          stop        = union[1]
          regions_arr[i+1].set_id_and_location_info(chr, start, stop)
          regions_arr[i+1].score = new_score
          regions_arr[i] = nil
#          @observed_max_seq_length = [@observed_max_seq_length, regions_arr[i+1].get_length()]
#          print "\tactual overlap = ", overlap_length, "\tlen1 = ", len1, "\tlen2 = ", len2
#          print "\tinter_peak_distance = ", inter_peak_distance, "\tscore1 = ", score1, "\tscore2 = ", score2, "\n"
#          print "\tchr",chr,"\tstart=", start1, "\tstop1 = ", stop1, "\tstart2 = ", start2, "\tstop2 = ",stop2, "\n"
#          gets
          c1+=1
        else
          c +=1
          score1 = regions_arr[i].score
          score2 = regions_arr[i+1].score
 #         print "overlap too small: minimal_overlap =  ", minimal_overlap, "\tactual overlap = ", overlap_length
#          print "\tactual overlap = ", overlap_length, "\tlen1 = ", len1, "\tlen2 = ", len2
#          print "\tinter_peak_distance = ", inter_peak_distance, "\tscore1 = ", score1, "\tscore2 = ", score2, "\n"
#          gets
        end
      end
    end
    regions_arr.compact!
    if(c1 > 0)
  #    print "merged: ", c1,"\n"
    end
    if(c > 0) 
#      print "not merged due to insufficient overlap: ", c,"\n"
    end
#    print "after processing overlap: regions_arr.length = ", regions_arr.length, "\n"
#    gets
  end
  
  def ChipSeqDataset.create(dataset_id, path, seq_file, scores_file, min_seq_length, max_seq_length, min_score, max_score)
    dataset = ChipSeqDataset.new(seq_file, scores_file, min_seq_length, max_seq_length, min_score, max_score, dataset_id)
    return dataset
  end
  
#  def remove_bottom_scoring_k_percent_regions(k)
##    num_to_remove = ((1-k) * @dataset_seq_regions.length).to_i
#    num_to_remove = (k * @dataset_seq_regions.length).to_i
#    print @id, "\tdataset_seq_regions.length = ", @dataset_seq_regions.length,"\n"
#    print "num_to_remove = ", num_to_remove, "\n"
#    sort_descending_by_score()
#    (1..num_to_remove).each do |i|
#      @dataset_seq_regions[@dataset_seq_regions.length - i] = nil
#    end
#    @dataset_seq_regions.compact!
#    print @id, "\tdataset_seq_regions.length = ", @dataset_seq_regions.length,"\n"
##    gets
#    GC.start
#  end

  def update_total_num_regions()
    @total_num_regions = 0
    k = @dataset_seq_regions.keys
    k.each do |chr|
      @total_num_regions += @dataset_seq_regions[chr].length
    end
    return @total_num_regions
  end

  @fl_done = false

  def remove_bottom_scoring_fixed_threshold(num_to_remove)
#    print @id, "\t@total_num_regions = ", @total_num_regions,"\n"
#    print @dataset_specific_parameters["dataset_id"], "\ttotal_num_regions = ", @total_num_regions,"\n"
   
#    print "num_to_remove = ", num_to_remove, "\n"
    
    @to_exclude_from_dataset_analysis = {}
#    min_score_value = @dataset_seq_regions.values.flatten.sort{|a,b| b.score <=> a.score}[@total_num_regions - num_to_remove].score
    i = 0
    to_delete = {}
    max_score_removed = 0 
    min_score_removed = 0
    positive_set_threshold = @total_num_regions - num_to_remove
    excluded_set_bottom_threshold = 2*(@total_num_regions - num_to_remove)
    excluded_set_top_threshold = 3*(@total_num_regions - num_to_remove)

    if(@dataset_specific_parameters["dataset_id"].scan("DNase") != [])
#      print "positive_set_threshold = #{positive_set_threshold}\n"
#      print "negative_set_threshold = #{num_to_remove}\n"
#       print "\npositive set: top #{positive_set_threshold} regions (remove remaining #{num_to_remove} from the analysis)"
    end
  
    @dataset_seq_regions.values.flatten.sort{|a,b| b.score <=> a.score}.each do |r|
        
#       if(r.score < 0.1)
##          if(i < num_to_remove)
#            r.to_use_in_sample_space = false
#            r.not_use_at_all_in_the_analysis = true       
#       else
#         r.to_use_in_sample_space = true
#         r.not_use_at_all_in_the_analysis = false
#       end
#       next
          
      
      if(true)#@dataset_specific_parameters["dataset_id"].scan("DNase") != [])
        if(i >= positive_set_threshold)
#          if(i < num_to_remove)
            r.to_use_in_sample_space = true#false
            r.not_use_at_all_in_the_analysis = true       
#          else
#            r.score = 0.0  
#          end
        else
          r.to_use_in_sample_space = true
          r.not_use_at_all_in_the_analysis = false
        end
        i += 1
        next
      end
      
      if(i < positive_set_threshold)
      # do nothing -> leave those values to be used as positive set
      elsif(i >= positive_set_threshold and i < excluded_set_bottom_threshold)
        
        # use to assign scores when overlapping with other datasets, but not for the original
        r.to_use_in_sample_space = true
        r.not_use_at_all_in_the_analysis = true
        if(i == @total_num_regions - num_to_remove)
          max_score_removed = r.score
        end
        min_score_removed = r.score
#        print i,"\tremoving ", r.id, "\t", r.score,"\n"
#        to_delete[r.id] = 1
      elsif(i < excluded_set_top_threshold)
        r.score = 0.0
        r.to_use_in_sample_space = false    
        r.not_use_at_all_in_the_analysis = true
      else
        r.to_use_in_sample_space = false    
        r.not_use_at_all_in_the_analysis = true
      end
      i += 1
#      if(i>3000 and i < 4000)
#        print i,"\t", r.to_use_in_sample_space,"\n"
#      end
    end

#    print "threshold 1 = #{@total_num_regions - num_to_remove}\n"
#    print "threshold 2 = #{2*(@total_num_regions - num_to_remove)}\n"

#    gets
    
#    k = @dataset_seq_regions.keys
#    k.each do |chr|
#      @dataset_seq_regions[chr].delete_if{|e| to_delete[e.id] != nil}
#    end
    
#    print "min_score_value = ", min_score_value, "\n"
#    k = @dataset_seq_regions.keys
#    k.each do |chr|
#      @dataset_seq_regions[chr].delete_if{|e| e.score < min_score_value}
#    end
    
#    sort_descending_by_score()
#    (1..num_to_remove).each do |i|
#      @dataset_seq_regions[@dataset_seq_regions.length - i] = nil
#    end
#    @dataset_seq_regions.compact!
    update_total_num_regions()
 #   if(@fl_done == false)
  #   print "done\n"
      
  #  else
   #   @fl_done == true
  #  end
#    print @dataset_specific_parameters["dataset_id"], "\t@total_num_regions = ", @total_num_regions,"\n"
#    print "min_score_removed = ", min_score_removed,"\tmax_score_removed = ", max_score_removed,"\n"
    GC.start
  end

  def get_known_binding_consensus()
    if(@known_consensus == nil)
      return "TTTCGCGC"
    else
      return @known_consensus
    end
  end

  def get_existing_known_pssm_files(pssms_path)
    if(pssms_path != nil)
        known_pssm_files = []
	if(FileTest.exist?(pssms_path + "pssm_"+@dataset_specific_parameters["dataset_id"]) == true)
		known_pssm_files.push(pssms_path + "pssm_"+@dataset_specific_parameters["dataset_id"])
	end
	if(FileTest.exist?(pssms_path + "pssm_"+@dataset_specific_parameters["dataset_id"]+"_Jaspar.txt") == true)
		known_pssm_files.push(pssms_path + "pssm_"+@dataset_specific_parameters["dataset_id"]+"_Jaspar.txt")
	end
	if(FileTest.exist?(pssms_path + "pssm_"+@dataset_specific_parameters["dataset_id"]+"_TRANSFAC.txt") == true)
		known_pssm_files.push(pssms_path + "pssm_"+@dataset_specific_parameters["dataset_id"]+"_TRANSFAC.txt")
	end
	return known_pssm_files
    else
   	return []
    end
  end

#  def get_known_pssm_files(out_path)
  def get_known_pssm_files(pssms_path)
    dummy_pssm_name = "dummy.pssm"
    if(pssms_path == nil)
	return dummy_pssm_name
    end
    print "pssms_path = ", pssms_path,"\n"
    existing_pssm_files = get_existing_known_pssm_files(pssms_path)
#     print "existing_pssm_files = ", existing_pssm_files.inspect,"\n"
#     $stdin.gets
    if(pssms_path == nil or existing_pssm_files == [])
#      if(@dataset_specific_parameters["known_consensus"] == nil)
        return dummy_pssm_name
#      else
#        pssm_file = create_new_known_pssm_file_from_IUPAC_consensus(pssms_path)
#        @dataset_specific_parameters["known_pssm_files"] = [pssm_file]
#      end      
    else
      @dataset_specific_parameters["known_pssm_files"] = existing_pssm_files
    end
    return @dataset_specific_parameters["known_pssm_files"]
  end

#    if(@known_pssm_files == nil)
#      if(@known_consensus == nil)
#      #  return "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/new_peaks/pssms/pssm_E2F.txt"
#        return [out_path + "pssm_E2F.txt"]
#      else
#        if(exist_known_pssm_files(pssms_path, @id) == true)  
#     #     @known_pssm_file = out_path + "pssm_"+@id+".txt"
#          @known_pssm_files = [pssms_path + "pssm_"+@id+".txt"]
#          if(FileTest.exist?(pssms_path + "pssm_"+@id+"Jaspar.txt") == true)
#            @known_pssm_files.push(pssms_path + "pssm_"+@id+"Jaspar.txt")
#          end
#          if(FileTest.exist?(pssms_path + "pssm_"+@id+"TRANSFAC.txt") == true)
#            @known_pssm_files.push(pssms_path + "pssm_"+@id+"TRANSFAC.txt")
#          end
#        else
#      
#        end
#   #     return "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/new_peaks/pssms/pssm_"+@id+".txt"
#        return @known_pssm_files
#      end
#    else
#      return @known_pssm_files
#    end
#  end

  def create_new_known_pssm_file_from_IUPAC_consensus(pssms_path)
    concensus_IUPAC = get_known_binding_consensus()
    pssm_file = pssms_path + "pssm_"+@dataset_specific_parameters["dataset_id"]+".txt"
    if(FileTest.exist?(pssm_file) == false)
#      executable = "/research/labs/compbio/ohler/pubs/Georgiev08/cERMIT/Jan_2009/IUPAC_to_PSSM/IUPAC_to_PSSM_32bit"
      executable = "IUPAC_to_PSSM_32bit"
      command    = executable + " " + concensus_IUPAC + " " + pssm_file
      system(command)
    end
    return pssm_file
  end

  def test_create_known_pssm_file_from_IUPAC_consensus()
    concensus_IUPAC = "ATTGG"
    pssm_out_file = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/pssms/test_pssm1"
    ChipSeqDataset.create_known_pssm_file_from_IUPAC_consensus()
  end


  # seq_id assumed format: chr?:start_location-stop_location
  def ChipSeqDataset.extract_chr(seq_id)
    return seq_id.split(":")[0].split("chr")[1].to_s
  end
  # seq_id assumed format: chr?:start_location-stop_location
  def ChipSeqDataset.extract_start(seq_id)
    return seq_id.split(":")[1].split("-")[0].to_i
  end
  # seq_id assumed format: chr?:start_location-stop_location
  def ChipSeqDataset.extract_stop(seq_id)
    return seq_id.split(":")[1].split("-")[1].to_i
  end
  
  # expected input format: >seq_id score
  #                        AAATGTGTGTG....
  #>seq_id  chr?:<start>:<stop> score
  def read_seq_and_scores_FASTA_format(seq_file)
    lines_seq = IO.read(seq_file).split('>')
#    dataset_seq_regions = []
    dataset_seq_regions = {}
    chr = ""
    IO.read(seq_file).each do |l|
      if(l.scan(">") != [])
        arr           = l.split("\s")
        seq_id        = arr[0].gsub(/>/, "")
        loc_data      = arr[1]
        score         = arr[2].to_f
        chr           = ChipSeqDataset.extract_chr(location_data)
        start         = ChipSeqDataset.extract_start(location_data)
        stop          = ChipSeqDataset.extract_stop(location_data)
        peak_location = arr_scores[3].to_i
        if(peak_location == nil)
          peak_location = (stop + start) / 2
        else
          if(peak_location < start)
            peak_location += start
          end
        end
        
        strand     = "+"
        seq        = ""
        args = {'id'=>seq_id,'chr'=>chr,'start'=>start,'stop'=>stop,'peak_location'=>peak_location,'strand'=>strand,'seq'=>seq,'score'=>score}
        seq_region = SeqRegion.new(args)
        if(dataset_seq_regions[chr] == nil)
          dataset_seq_regions[chr] = []
        end
        dataset_seq_regions[chr].push(seq_region)
#        dataset_seq_regions.push(seq_region)
      else
        sequence = l.strip.upcase
#        dataset_seq_regions.last.seq<<sequence
        dataset_seq_regions[chr].last.seq<<sequence
      end
    end
    return dataset_seq_regions
  end

  def find_offset_best_match(seq1, seq2)
    # assume seq1 is longer
    if(seq1[0...seq2.length] == seq2)
      return 0
    elsif(seq1[50...(50+seq2.length)] == seq2)
      return 50
    end
    (0...(seq1.length - seq2.length + 1)).each do |i|
      if(seq1[i...(i+seq2.length)] == seq2)
        return i
      end
    end
    return nil
  end
#  seq1 = "aaattg"
#  seq2 = "aatt"
#  find_offset_best_match(seq1, seq2)

#  def fix_short_chip_seq_coords(dataset_ids, species)
#    dataset_ids.each do |dataset_id|
#      in_file = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/new_peaks0313/"+species+dataset_id
#      out_file = in_file + "_processed"
#      f_out = File.open(out_file, "w")
#      lines = IO.readlines(in_file)
#      lines.each  do |l|
#        arr = l.strip.split("\s")
#        score = arr[1]
#        peak  = arr[2]
#        start = arr[0].split(":")[1].split("-")[0].to_i
#        stop  = arr[0].split(":")[1].split("-")[1].to_i
#        chr   = arr[0].split(":")[0]
#        if(stop-start < 100)
#          start = start - 50
#          stop  = stop + 50
#        end      
#        f_out.write(chr+":"+start.to_s+"-"+stop.to_s+"\t"+score+"\t"+peak+"\n")
#      end
#      f_out.close()
#      print dataset_id, "\tdone\n"
##      gets
#    end
#  end
#  
#  def fix_all()
#    dataset_ids = ["ES_cMyc_score.out", "ES_CTCF_score.out", "ES_E2f1_score.out", "ES_Esrrb_score.out", "ES_Klf4_score.out", "ES_Nanog_score.out",
#                    "ES_n-Myc_score.out", "ES_Oct4_score.out", "ES_p300_score.out", "ES_Smad1_score.out", "ES_Sox2_score.out", "ES_STAT3_score.out",
#                    "ES_Suz12_score.out","ES_Tcfcp2I1_score.out", "ES_Zfx_score.out"]  
#    species = "Mouse"
#    fix_short_chip_seq_coords(dataset_ids, species)
#    
#    dataset_ids = ["CD4_CTCF_score.out", "Hela_STAT1_score.out"]
#    species = "Human"
#    fix_short_chip_seq_coords(dataset_ids, species)
#  end
#  fix_all()
  
#  def read_seq_and_scores_cERMIT_format(seq_file, scores_file)
  def read_seq_and_scores_cERMIT_format(peaks_file)
     print "\nprocessing peaks file: ", peaks_file
    $stdout.flush
#    gets
    lines_scores = IO.read(peaks_file).split("\n")
#    dataset_seq_regions = []
    dataset_seq_regions = {}
    (0...lines_scores.length).each do |i|
      seq           = nil#lines_seq[2*i].gsub('X', "")
      arr_scores    = lines_scores[i].split("\s")
      score         = arr_scores[1].to_f
      seq_id        = arr_scores[0]
      chr           = ChipSeqDataset.extract_chr(seq_id)
      start         = ChipSeqDataset.extract_start(seq_id)
      stop          = ChipSeqDataset.extract_stop(seq_id)
      peak_location = arr_scores[2].to_i
      if(peak_location < start)
        peak_location += start
      end
        
      strand        = "+"
      args = {'id'=>seq_id,'chr'=>chr,'start'=>start,'stop'=>stop,'peak_location'=>peak_location,'strand'=>strand,'seq'=>seq,'score'=>score}
#      print args.inspect
#      gets
      seq_region    = SeqRegion.new(args)
      if(dataset_seq_regions[chr] == nil)
        dataset_seq_regions[chr] = []
      end
      dataset_seq_regions[chr].push(seq_region)
#      dataset_seq_regions.push(seq_region)
    end 
    
#     if(@fl_done == true
  #  print "done\n"
    return dataset_seq_regions
  end
  
# process scores
  def ChipSeqDataset.sort_ascending_by_score(regions_arr)
    regions_arr.sort!{|a,b| a.score <=> b.score}
  end  
  def ChipSeqDataset.sort_descending_by_score(regions_arr)
    regions_arr.sort!{|a,b| b.score <=> a.score}
  end  
  def ChipSeqDataset.sort_ascending_by_location(regions_arr)
    regions_arr.sort!{|a,b| a.compare_loc(b)}
  end
  def ChipSeqDataset.apply_log_transform(regions_arr)
    regions_arr.collect!{|a| a.score = Math.log(a.score);a}
  end
  def ChipSeqDataset.toggle_sign(regions_arr)
    regions_arr.collect!{|a| a.score = -a.score;a}
  end  
   
  def create_cERMIT_input_and_run_files(analyzed_datasets, out_path, pssms_path, cERMIT_executable = "cERMIT", oligo_size_file = "oligos_size_5")
#    c = 0
#    @dataset_seq_regions.values.flatten.sort{|a,b| b.score <=> a.score}.each do |r|
#      if(r.score > 0)
#        c += 1
#      end
#    end
#    print "non-zero = ", c,"\n"
#    gets
   
      num = out_path.split("/").length
      print "out_path: ", out_path, "\nnum = ", num, "\n"
#      $stdin.gets
      prefix = "./"
      (0...(num-1)).each do 
	prefix<<"../"
      end
      print "prefix: ", prefix, "\n"
#      $stdin.gets

      print "analyzed_datasets: ", analyzed_datasets.inspect,"\n"
#      $stdin.gets
 
    if(FileTest.exist?(out_path) == false)
      print "directory\n", out_path, "\ndoesn't exist creating..."
      Dir.mkdir(out_path)
      print "222done\n"
    end

#    create_known_pssm_file_from_IUPAC_consensus(out_path)
#    known_consensus           = get_known_binding_consensus()
    
#    pssms_path = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/pssms/"
    pssm_files_with_full_path = get_known_pssm_files(pssms_path)
    pssm_files = pssm_files_with_full_path
#    pssm_files_with_full_path.each do |pssm_file|
#      pssm_files.push(pssm_file.split("/").last)
#    end
    
    # create the files in the corresponding directory
    dataset_evidence_file = out_path + @dataset_specific_parameters["dataset_id"] + "_evidence"
    dataset_seq_file      = out_path + @dataset_specific_parameters["dataset_id"] + "_seq"

#    t = Timer.new()
    output_seq_and_scores(dataset_seq_file, dataset_evidence_file)
#    print "after 'output_seq_and_scores'\n"
#    t.print_time()
    
    orth_dataset_arr = []
    # assuming no orthologs
#    (1...out_seq_file_arr.length).each do |i|
#      orth_dataset_arr.push(dataset_seq_file_arr[i])
#    end

    # assume that we run cERMIT from same directory as the 'seq_file' file
    dataset_seq_file = @dataset_specific_parameters["dataset_id"] + "_seq"

  # 2> sequence_file_list
  # line contents: <dataset_id>_seq <orth1_dataset_id>_seq <orth2_dataset_id>_seq ...
    sequence_file_list_contents = create_sequence_file_list_contents(dataset_seq_file, orth_dataset_arr)
    sequence_file_list          = out_path + "seq_file_list_" + @dataset_specific_parameters["dataset_id"]
    create_file(sequence_file_list, sequence_file_list_contents)
    sequence_file_list          = "seq_file_list_" + @dataset_specific_parameters["dataset_id"]
        
    # assume that we run cERMIT from same directory as the 'evidence' file
    dataset_evidence_file = @dataset_specific_parameters["dataset_id"] + "_evidence"
    out_dir = "output"

    index = 1
    pssm_files.each do |pssm_file|
     
 #     prefix = "./../."
      if(pssm_file.scan("dummy.pssm") != [])
        pssm_short = nil
      else
#        print pssm_files.inspect
#	$stdin.gets
        if(analyzed_datasets.length > 1)
 #   	  prefix = "./../../."

        else
#	  print analyzed_datasets.inspect
#	  $stdin.gets
	end


    
	
        pssm_short = prefix+pssm_file
#        pssm_short = pssm_file.split("/").last
#        command = "cp "+pssm_file+" "+out_path+pssm_short
#        system(command)
      end

       suffix  = ""
#       if(pssm_file.scan("Jaspar") != [])
#         suffix<<"_Jaspar"
#       elsif(pssm_file.scan("TRANSFAC") != [])
#         suffix<<"_TRANSFAC"
#       end
      

  # 1> evidence_file_list
  # line contents: evidence_<dataset_id> <pssm> <known_consensus>
      evidence_file_list_contents = create_evidence_file_list_contents(dataset_evidence_file, pssm_short, known_consensus)
      evidence_file_list          = out_path + "evidence_file_list_" + @dataset_specific_parameters["dataset_id"] + suffix
      create_file(evidence_file_list, evidence_file_list_contents)
      evidence_file_list          = "evidence_file_list_" + @dataset_specific_parameters["dataset_id"] + suffix

#      print "prefix: ", prefix, "\n"
#      $stdin.gets

 #   prefix = prefix + "./"
  # 3> run_file
  # line contents: <cERMIT executable> evidence_file_list sequence_file_list output_dir
 #    print "prefix: ", prefix, "\n"
 #     $stdin.gets

      run_file_contents = create_run_file_contents(prefix+cERMIT_executable, evidence_file_list, sequence_file_list, out_dir+suffix)
#     run_file          = out_path + "run_file_" + @dataset_specific_parameters["dataset_id"] + suffix
      run_file          = out_path + "do_cERMIT_analysis"

      create_file(run_file, run_file_contents)
      
      index += 1
    end
    
#    second_run_file = run_file + "11"
#    second_run_file_contents = create_run_file_contents("./"+cERMIT_executable+"1", evidence_file_list+"1", sequence_file_list, out_dir+"1")
#    create_file(second_run_file, second_run_file_contents)
    command = "chmod u+rwx "+out_path+"do_cERMIT_analysis"
    system(command)
    
#    oligo_size_file   = "/research/labs/compbio/ohler/pubs/Georgiev08/cERMIT/Jan_2009/oligos_size_5"
#    oligo_size_file   = "oligos_size_5"
#    command = "cp "+oligo_size_file+" "+out_path+"oligos_size_5"
#    system(command)
    
#    file_R_scrip   = "run_R_script"
#    command = "cp "+file_R_scrip+" "+out_path+"run_R_script"
#    system(command)

#    file_R_scrip   = "generate_logo.R"
#    command = "cp "+file_R_scrip+" "+out_path+"generate_logo.R"
#    system(command)

#    cERMIT_executable_with_full_path = "/research/labs/compbio/ohler/pubs/Georgiev08/cERMIT/Jan_2009/cERMIT"
#    cERMIT_executable_with_full_path = "cERMIT"
#    command = "cp "+cERMIT_executable_with_full_path+" "+out_path+cERMIT_executable
#    system(command)
    
#    command = "cp "+cERMIT_executable_with_full_path+"1"+" "+out_path+cERMIT_executable+"1"
#    system(command)
    
#    return run_file
  end
    
  def output_seq_and_scores(out_seq_file, out_scores_files)
    f_out_seq = File.open(out_seq_file, "w")
    f_out_score = File.open(out_scores_files, "w")
    max_seq_length = get_max_length()
    c = 0
#    print "out_seq_file: #{out_seq_file}\nout_scores_files: #{out_scores_files}\n"
    @dataset_seq_regions.values.flatten.sort{|a,b| b.score <=> a.score}.each do |seq_region|
#      print seq_region.id,"\t", seq_region.score, "\n"
      if(seq_region.score > 0)
        c+=1
      end
      if(seq_region.to_use_in_sample_space == false)
#        print "seq_region.to_use_in_sample_space == false\n"
#        next
      end
      f_out_score.write(seq_region.id + "\t" + seq_region.score.to_s + "\n")
      seq_in_cERMIT_input_format = seq_region.get_cERMIT_format(max_seq_length)
      f_out_seq.write(seq_in_cERMIT_input_format)
    end
    f_out_seq.close()
    f_out_score.close()  
#    print "num non-zero output = ", c, "\n"
#    gets
  end
   
  def get_max_length()
    max_length = 0
    @dataset_seq_regions.each do |chr, regions_on_chr|
      regions_on_chr.each do |r|
        max_length = [max_length, r.seq_length].max
      end
    end
    return max_length
  end  

  
#  def run_cERMIT(run_file)
#    command = run_file
#    system(command)
#  end
    
  # TEST
  def ChipSeqDataset.test()
    print "ERROR\nold code\n"
    gets
    path           = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/mouse/"
    seq_file       = path + "MouseES_cMyc_sequence.out"
    scores_file    = path + "MouseES_cMyc_score.out"
    min_seq_length = 25
    max_seq_length = 3000
    min_score      = -1.0e10
    max_score      = 5
    known_cons     = "CACGTG"
    dataset_id     = "cMyc"
    p              = ChipSeqDataset.new(seq_file, scores_file, min_seq_length, max_seq_length, min_score, max_score, known_cons, dataset_id);nil
    run_file       = p.create_cERMIT_input_and_run_files(path+"test/")
    print "run_file: ", run_file, "\n"
#    gets
#    p.run_cERMIT(run_file)
  end

  def ChipSeqDataset.test_fasta()
    print "ERROR\nold code\n"
    gets
    path           = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/c-Myc/"
    seq_file       = path + "test_fasta"
    scores_file    = path + "MouseES_cMyc_score.out"
    min_seq_length = 25
    max_seq_length = 3000
    min_score      = -1.0e10
    max_score      = 5#1 - 1.0e-10
    dataset_id     = "cMyc"
    p              = ChipSeqDataset.new(seq_file, min_seq_length, max_seq_length, min_score, max_score, dataset_id);nil
    run_file       = p.create_cERMIT_input_and_run_files(path)
    print "run_file: ", run_file, "\n"
#    gets
#    p.run_cERMIT(run_file)
  end

private
  def create_evidence_file_list_contents(dataset_evidence_file, pssm_file, known_consensus)
    evidence_file_list_contents = ""
    evidence_file_list_contents<<dataset_evidence_file +"\t"
    if(pssm_file != nil)
       evidence_file_list_contents<<pssm_file + "\n"
    end
#    if(known_consensus != nil)
#      evidence_file_list_contents<<known_consensus
#    end
    return evidence_file_list_contents    
  end
  
  def create_sequence_file_list_contents(dataset_seq_file, orth_dataset_arr)
    sequence_file_list_contents = ""
    sequence_file_list_contents<<dataset_seq_file
    orth_dataset_arr.each do |orth_seq_file|
      sequence_file_list_contents<<"\t"+orth_seq_file
    end
    return sequence_file_list_contents
  end
  
  def create_run_file_contents(cERMIT_executable, evidence_file_list, sequence_file_list, output_dir)
    run_file_contents = "\#!/usr/bin/env bash\n"
    run_file_contents<<cERMIT_executable + "\t"
    run_file_contents<<evidence_file_list + "\t"
    run_file_contents<<sequence_file_list + "\t"
#    run_file_contents<<"oligos_size_5\t"
    run_file_contents<<output_dir + " chip_seq\n"    
    return run_file_contents
  end
  
  def create_file(file_name, contents)
    f_out = File.open(file_name, "w")
    f_out.write(contents)
    f_out.close()
  end
  
  def ChipSeqDataset.apply_filter(filter, seq_regions_arr, global_params)
    count = 0
    total = 0
    seq_regions_arr.collect! do |seq_region|
      res = filter.call(seq_region, global_params)
      total += 1
      if(res == nil)
        count += 1
#        print seq_region.id, "\tseq_len = ", seq_region.seq_length, "\t", "score = ", seq_region.score, "\n"
#        seq_region.show_loc()
        nil
      else
        res  
      end
    end.compact!
#    print "number of filtered out regions = ", count, "/", total, "\n"
  end
  
#  def rev_complement_proc(seq)
#    seq.split("").collect { |el|
#      case el
#        when "A"; el = "T"
#        when "a"; el = "t"
#        when "T"; el = "A"
#        when "t"; el = "a"
#        when "G"; el = "C"
#        when "g"; el = "c"
#        when "C"; el = "G"
#        when "c"; el = "g"
#        else el = el
#      end
#    }.join("").reverse
#  end
    
# end of class
end

#ChipSeqDataset.test()
#ChipSeqDataset.test_fasta()
#load("/home/sgg4/ruby_ws/gene_sets/ChipSeqDataset.rb")

