#!/usr/bin/env ruby

#load("/home/sgg4/ruby_ws/gene_sets/ChipSeqDataset.rb")
load("ChipSeqDataset.rb")

class DataProcessorCERMIT
  
  # @datasets[id] = dataset
  # dataset (object) -> :id, :dataset_seq_regions
  attr_accessor :datasets

#  DataProcessorCERMIT.input_params["parameters_file"]
  @@input_params = {"parameters_file"=>"params_file"}
  def self.input_params
    @@input_params
  end

  def DataProcessorCERMIT.init_input_paramteres(pars)
    pars.each do |k,v|
      if(DataProcessorCERMIT.input_params.keys.include?(k) == true)
        DataProcessorCERMIT.input_params[k] = v
      else
        print "ERROR: unrecognized input parameter: ", k, "\t", v,"\n"
#        $stdin.gets
      end
    end
#    print DataProcessorCERMIT.input_params.inspect
#    $stdin.gets
  end

  # ignore all dataset-specific paramteres before the global paramters line
  def read_global_parameters_line(lines)
    params_line = ""
    curr_line_index = 0
    (0...lines.length).each do |i|
      if(is_valid_global_params_input_line(lines[i]) == true)
        params_line = lines[i].split("\s")
        curr_line_index += 1
        break
      end
      curr_line_index += 1
    end
    
    if(curr_line_index >= lines.length)
      print "ERROR: 'initialize', no datasets input lines!\n"
      gets
    end
    
    # read global params (key-value pairs)
    @global_params = {}
    params_line.each do |e|
      arr = e.strip.split("=")
      @global_params[arr[0]] = arr[1]
    end
    if(@global_params["species"] == nil)
	@global_params["species"] = "human"
	print "species (default): human\n"
    end
    if(@global_params["region_max_score"] == nil)
	@global_params["region_max_score"] = 10.0
	print "region_max_score (default): 10.0\n"
    end
    if(@global_params["out_path"] == nil)
	@global_params["out_path"] = "./"
	print "out_path (default): ./\n"
    end
    if(@global_params["peaks_file_path"] == nil)
	@global_params["peaks_file_path"] = "./data/"
	print "peaks_file_path (default): ./data/\n"
    end
    if(@global_params["known_pssm_path"] == nil)
	@global_params["known_pssm_path"] = "./data/pssms/"
	print "known_pssm_path (default): ./data/pssms/\n"
    end

    @global_params["analyzed_datasets"] = []
#     print "run parameters:\n", @global_params.inspect, "\n"
#     $stdin.gets
    return curr_line_index
  end
  

   def execute_ensemble_pre_processing_GENERAL(lines, curr_line_index)
#    print "ensemble_pre_processing_GENERAL\n", @global_params["sample_space"], "\n"
    hard_threshold_to_remove  = nil
    bottom_fraction_to_remove = nil
    if(@global_params["sample_space"].scan("percent") != [])
      bottom_fraction_to_remove = [1.0 - @global_params["sample_space"].split("top_")[1].split("_percent")[0].to_i * 0.01, 0].max
    else
      hard_threshold_to_keep_from_top = @global_params["sample_space"].split("top_")[1].to_i
    end
#    print "hard_threshold_to_keep_from_top = ", hard_threshold_to_keep_from_top,"\n"
#    $stdin.gets
    id_of_dataset_to_use_for_sample_space = "all_datasets"
    load_all_datasets(lines, curr_line_index, id_of_dataset_to_use_for_sample_space, 
                                                                      bottom_fraction_to_remove, hard_threshold_to_keep_from_top)
#    print "loaded...\n"
#    $stdin.gets
    name_prefix = do_construct_sample_space_GENERAL(@global_params["sample_space"], @global_params["species"])
    output_all(hard_threshold_to_keep_from_top, name_prefix)
  end


  def execute_ensemble_pre_processing(lines, curr_line_index)
    print "ERROR: 'execute_ensemble_pre_processing', need to modify: output_all exepct two parameters, not one!!!\n"
    exit(1)

#    print "ensemble_pre_processing\n"
    hard_threshold_to_remove  = nil
    bottom_fraction_to_remove = nil
    if(@global_params["sample_space"].scan("_top_") != [])
      bottom_fraction_to_remove = [1.0 - @global_params["sample_space"].split("_top_")[1].to_i * 0.01, 0].max
    else
      hard_threshold_to_keep_from_top  = @global_params["sample_space"].split("ensemble_")[1].to_i
    end
    id_of_dataset_to_use_for_sample_space = "all_datasets"
    load_all_datasets(lines, curr_line_index, id_of_dataset_to_use_for_sample_space, 
                                                                      bottom_fraction_to_remove, hard_threshold_to_keep_from_top)
#    print "loaded\n"
#    gets
    name_prefix = do_construct_sample_space(@global_params["sample_space"], @global_params["species"])
    output_all(name_prefix)
  end
  
  def execute_dataset_as_sample_space_pre_processing(lines, curr_line_index)
    print "ERROR: 'execute_dataset_as_sample_space_pre_processing', need to modify: output_all exepct two parameters, not one!!!\n"
    exit(1)

#    print "dataset_as_sample_space_pre_processing\n"
#    id_of_dataset_to_use_for_sample_space = @global_params["sample_space"].split("dataset_")[1].split("_top_")[0]
#    print "using #{id_of_dataset_to_use_for_sample_space} to define the sample space\n"
    id_of_dataset_to_use_for_sample_space = ""
    hard_threshold_to_keep_from_top = nil
    bottom_fraction_to_remove       = nil
    if(@global_params["sample_space"].scan("_top_") != [])
      id_of_dataset_to_use_for_sample_space = @global_params["sample_space"].split("dataset_")[1].split("_top_")[0]
#      print "using #{id_of_dataset_to_use_for_sample_space} to define the sample space\n"
      bottom_fraction_to_remove        = [1.0 - @global_params["sample_space"].split("_top_")[1].to_i * 0.01, 0].max
    else
      hard_threshold_to_keep_from_top  = @global_params["sample_space"].split("_").last.to_i

      id_of_dataset_to_use_for_sample_space = @global_params["sample_space"].split("dataset_")[1].split("_#{hard_threshold_to_keep_from_top}")[0]
#       print "using #{id_of_dataset_to_use_for_sample_space} to define the sample space\n"
#       print @global_params["sample_space"].split("#{id_of_dataset_to_use_for_sample_space}").inspect,"\n"
#      hard_threshold_to_keep_from_top  = @global_params["sample_space"].split("#{id_of_dataset_to_use_for_sample_space}_")[1].to_i
    end
#     print "bottom_fraction_to_remove = ", bottom_fraction_to_remove,"\n"
#     print "hard_threshold_to_keep_from_top = ", hard_threshold_to_keep_from_top,"\n"
#    gets
    
    load_all_datasets(lines, curr_line_index, id_of_dataset_to_use_for_sample_space, bottom_fraction_to_remove, hard_threshold_to_keep_from_top)
    name_prefix = do_construct_sample_space(@global_params["sample_space"], @global_params["species"])
#     print "output_all\n"
    output_all(name_prefix)
  end
  
  def execute_upstream_known_genes_pre_processing(lines, curr_line_index) 
    print "ERROR: 'execute_upstream_known_genes_pre_processing', need to modify: output_all exepct two parameters, not one!!!\n"
    exit(1)

    name_prefix = do_construct_sample_space(@global_params["sample_space"], @global_params["species"])
    (curr_line_index...lines.length).each do |line_index|
      if(is_valid_dataset_param_input_line(lines[line_index]) == false)
#        print "IGNORING invalid line:\n", lines[line_index]
        next
      else
#        print lines[line_index],"\n"
      end
      
      @datasets = {}
      GC.start
      load_next_dataset(lines, line_index)
#      print "loaded\n"
#      gets
      output_all(name_prefix)
    end
  end

  def remove_empty_lines(lines)
#    print lines.inspect, "\n"
    lines_out = []
    lines.each do |l|
#       print l.strip.length, ":", l.strip,"\n"
      if(l.strip.length > 0)
	lines_out.push(l)
#        print l
      else
 #       print "skipping empty line!!!\n"
      end
    end
#    print lines_out.inspect, "\n"
#    $stdin.gets
    return lines_out
  end  

  def initialize(parameters_file)
    t = Timer.new()
    lines1 = IO.readlines(parameters_file)
    lines = remove_empty_lines(lines1)
    curr_line_index = read_global_parameters_line(lines)
    
    execute_ensemble_pre_processing_GENERAL(lines, curr_line_index)

#    name_prefix=""
#    if(@global_params["sample_space"].scan("ensemble") != [])
#      # need to load all datasets before extracting top K from each
#      execute_ensemble_pre_processing(lines, curr_line_index)
#      
#    elsif(@global_params["sample_space"].scan("upstream_known_genes") != [])
#      # process one dataset at a time
#      execute_upstream_known_genes_pre_processing(lines, curr_line_index)
#    elsif(@global_params["sample_space"].scan("dataset_") != [])
#      # need to load all datasets before extracting top K from each
##      bottom_fraction_to_remove = 0.0
#
#      execute_dataset_as_sample_space_pre_processing(lines, curr_line_index)
#
#    else
#      print "unsupported method of sample space construction!\n"
#      gets
#    end
    t.print_time
  end

private
  
  def load_next_dataset(lines, line_index)
    print "need to fix! 'ChipSeqDataset.new' etc.\n"
    gets
    max_seq_length = @global_params["max_seq_length"].to_i
    min_seq_length = @global_params["min_seq_length"].to_i
    min_score      = -1000#@global_params["region_min_score"].to_f
    max_score      = @global_params["region_max_score"].to_f

    dataset_params_line = lines[line_index..line_index][0]
#    print "dataset_params_line.inspect:\n", dataset_params_line.inspect
#    gets
    arr = dataset_params_line.strip.split("\s")

    dataset_id      = arr[0]
    seq_file        = arr[1]
    scores_file     = arr[2]
    known_consensus = arr[3]
    path            = extract_path(seq_file)
    print "processing #{dataset_id}..."
    dataset         = ChipSeqDataset.new(seq_file, scores_file, min_seq_length, max_seq_length, min_score, max_score, known_consensus, dataset_id)
    @datasets[dataset_id] = dataset
    print "done\n"
  end 

  def load_all_datasets(lines, dataset_input_lines_start_index, id_of_dataset_to_use_for_sample_space, 
                                                                           bottom_fraction_to_remove, hard_threshold_to_keep_from_top)
    t = Timer.new()
#    max_seq_length = @global_params["max_seq_length"].to_i
#    min_seq_length = @global_params["min_seq_length"].to_i
#    min_score      = @global_params["region_min_score"].to_f
#    max_score      = @global_params["region_max_score"].to_f
    @datasets      = {}
    lines[dataset_input_lines_start_index..-1].each do |l|
      arr = l.strip.split("\s")
      if(l.scan(/^#/) != [])
#        print "IGNORING invalid line:\n", l
        next
      else
#        print "line:\n", l,"\n"  
      end

      dataset_specific_parameters = {}
      dataset_specific_parameters["regions_arr_initialization"] = false
      arr.each do |key_value_pair|
        dataset_specific_parameters[key_value_pair.split("=")[0]] = key_value_pair.split("=")[1]
      end
            
#      print "dataset_specific_parameters:\n", dataset_specific_parameters.inspect
#      gets

 #     print "processing #{dataset_specific_parameters["dataset_id"]}..."
#      print @global_params.inspect
#      $stdin.gets

      dataset = ChipSeqDataset.new(@global_params, dataset_specific_parameters)
#       if(dataset == nil)
#         next
#       end

      if(bottom_fraction_to_remove != nil)
        if(bottom_fraction_to_remove >= 0 and bottom_fraction_to_remove < 1.0)
          if( (id_of_dataset_to_use_for_sample_space == "all_datasets") or (dataset_specific_parameters["dataset_id"] == id_of_dataset_to_use_for_sample_space) )
            num_to_remove_from_bottom = (bottom_fraction_to_remove * dataset.total_num_regions).to_i
            
            if(dataset_specific_parameters["dataset_id"] == id_of_dataset_to_use_for_sample_space)
              num_to_remove_from_bottom = 0
            end
            dataset.remove_bottom_scoring_fixed_threshold(num_to_remove_from_bottom)
          end
        else
          print "ERROR: bottom_fraction_to_remove = ", bottom_fraction_to_remove
          gets      
        end        
      elsif(hard_threshold_to_keep_from_top != nil)
        num_to_remove_from_bottom = dataset.total_num_regions - hard_threshold_to_keep_from_top
        
        if(dataset_specific_parameters["dataset_id"] == id_of_dataset_to_use_for_sample_space)
          num_to_remove_from_bottom = 0
        end
        
        if(num_to_remove_from_bottom < 10e-20)
          print "ERROR: num_to_remove_from_bottom = ", num_to_remove_from_bottom, "\nNOT removing any regions!\n"
          num_to_remove_from_bottom = 0
#          gets
        end
        dataset.remove_bottom_scoring_fixed_threshold(num_to_remove_from_bottom)
      end
      GC.start
      @datasets[dataset_specific_parameters["dataset_id"]] = dataset
#     print "done\n"
#      print dataset_specific_parameters["dataset_id"], "...processed and loaded\n"
    end
    t.print_time()
#    print "loading and processing of datasets done\n"
  end 
   
  def do_construct_sample_space_GENERAL(sample_space_param, species)
    name_prefix = ""
    if(sample_space_param.scan("percent") != [])
      top_fraction_to_consider = sample_space_param.split("top_")[1].split("_percent")[0].to_i * 0.01
        @global_params["ensemble_top_fraction_to_consider"] = top_fraction_to_consider.to_f
        name_prefix<<"ensemble_top_"+top_fraction_to_consider.to_s+"_"
    else
      hard_threshold_num_top = sample_space_param.split("top_")[1].to_i
      @global_params["ensemble_hard_threshold"] = hard_threshold_num_top.to_i
      name_prefix<<"top_" + hard_threshold_num_top.to_s + "_"
    end
#    print "hard_threshold_num_top = ", hard_threshold_num_top
#    $stdin.gets
    sample_space_constuctor  = self.method(:construct_sample_space_ensemble)
    construct_sample_space(sample_space_constuctor, species) 
    
    num_regions = get_num_regions_in_sample_space()
#    print "sample space constructed: num_regions = ", num_regions, "\n"
    return name_prefix
  end


  def do_construct_sample_space(sample_space_param, species)
    name_prefix = ""
    if(sample_space_param.scan("ensemble") != [])
#      print "ensemble...\n"
      if(sample_space_param.scan("_top_") != [])
        top_fraction_to_consider = sample_space_param.split("_top_")[1].to_i * 0.01
        @global_params["ensemble_top_fraction_to_consider"] = top_fraction_to_consider.to_f
        name_prefix<<"ensemble_top_"+top_fraction_to_consider.to_s+"_"
      else
        hard_threshold_num_top = sample_space_param.split("ensemble_")[1].to_i
        @global_params["ensemble_hard_threshold"] = hard_threshold_num_top.to_i
        name_prefix<<"ensemble_hard_threshold_top_"+hard_threshold_num_top.to_s+"_"
      end
      sample_space_constuctor  = self.method(:construct_sample_space_ensemble)
      construct_sample_space(sample_space_constuctor, species) 
    elsif(sample_space_param.scan("upstream_known_genes") != [])
#      print "'upstream_known_genes': need to implement!!!\n"
      gets
#      sample_space_constuctor  = self.method(:construct_sample_space_using_upstream_of_TSS)
#      num_bp_upstream_of_TSS   = sample_space_param.split("upstream_known_genes_")[1].split("_")[0].to_i
#      num_bp_downstream_of_TSS = sample_space_param.split("upstream_known_genes_")[1].split("_")[1].to_i
#      construct_sample_space(sample_space_constuctor, num_bp_upstream_of_TSS, num_bp_downstream_of_TSS, species)
#      @global_params["known_genes"] = "upstream_"+num_bp_upstream_of_TSS.to_s+"_downstream:"+num_bp_downstream_of_TSS.to_s
#      name_prefix<<"known_genes_upstream:"+num_bp_upstream_of_TSS.to_s+"_downstream:"+num_bp_downstream_of_TSS.to_s + "_"
    elsif(sample_space_param.scan("dataset_") != [])
      hard_threshold_to_keep_from_top = nil
      fraction_to_consider = nil
      id_of_dataset_to_use_for_sample_space = ""
      
      if(sample_space_param.scan("_top_") != [])
        id_of_dataset_to_use_for_sample_space = sample_space_param.split("dataset_")[1].split("_top_")[0]
        bottom_fraction_to_remove             = [1.0 - sample_space_param.split("_top_")[1].to_i * 0.01, 0].max
      else
        hard_threshold_to_keep_from_top       = sample_space_param.split("_").last.to_i
        id_of_dataset_to_use_for_sample_space = sample_space_param.split("dataset_")[1].split("_#{hard_threshold_to_keep_from_top}")[0]
      end

      fraction_to_consider = ""
      if(hard_threshold_to_keep_from_top == nil)
        fraction_to_consider = sample_space_param.split("dataset_")[1].split("_top_")[1].to_f * 0.01
      else
        fraction_to_consider = "hard_threshold_"+hard_threshold_to_keep_from_top.to_s+"_"
      end
      
#      id_of_dataset_to_use_for_sample_space = sample_space_param.split("dataset_")[1].split("_top_")[0]
#      fraction_to_consider = sample_space_param.split("dataset_")[1].split("_top_")[1].to_f * 0.01
      sample_space_constuctor = self.method(:construct_sample_space_using_another_dataset)
      construct_sample_space(sample_space_constuctor, id_of_dataset_to_use_for_sample_space) 
      @global_params["sample_space_dataset"] = "top_"+fraction_to_consider.to_s+"_dataset_"+id_of_dataset_to_use_for_sample_space
      name_prefix<<"sample_space_"+"_top_"+fraction_to_consider.to_s+"_dataset_"+id_of_dataset_to_use_for_sample_space + "_"
    else
      # use p300
#      print "p300 not implemented yet!\n"
      gets
    end
    
    num_regions = get_num_regions_in_sample_space()
#    print "sample space constructed: num_regions = ", num_regions, "\n"
    return name_prefix
  end
  
  def get_num_regions_in_sample_space()
    if(@sample_space != nil)
      num = 0
      @sample_space.each do |chr, regions_arr|
        num += regions_arr.length
      end
      return num
    else
      return 0  
    end
  end
 
  def construct_sample_space(sample_space_constuctor, *args)
    if(args.length == 1)
      sample_space_constuctor.call(args[0])
    elsif(args.length == 2)
      sample_space_constuctor.call(args[0], args[1])
    elsif(args.length == 3)
      sample_space_constuctor.call(args[0], args[1], args[2])
    else
      print "ERRRO: 'construct_sample_space', args.length = ", args.length
      gets
    end
  end

 def construct_sample_space_ensemble(species)
    c = 0
    print "construct sample space for ", @datasets.keys.inspect,"..."
    $stdout.flush
    @sample_space = {}
    @datasets.each do |id, dataset|
      dataset.dataset_seq_regions.each do |chr, regions_on_chr|
        regions_on_chr.each do |r|
          if(r.not_use_at_all_in_the_analysis == false)
            c += 1
            seq_id        = r.id
            score         = r.score
            start         = extract_start(seq_id)
            stop          = extract_stop(seq_id)
            strand        = "+"
            seq           = r.seq
            peak_location = r.peak_location
            args = {'id'=>seq_id,'chr'=>chr,'start'=>start,'stop'=>stop,'peak_location'=>peak_location,'strand'=>strand,'seq'=>seq,'score'=>score}
            seq_region = SeqRegion.new(args)
            if(@sample_space[chr] == nil)
              @sample_space[chr] = []
            end
            @sample_space[chr].push(seq_region)
          end
        end
      end
    end
    print " (#{c} regions)...done\n"# constructing sample space from ensemble of all datastes: total number regions = #{c}\n"
#     if(c >= 5000)
#       print "merging overlapping regions in sample space\n"
#     end
    @sample_space.each do |chr, regions_arr|
#       if(c >= 5000)
#         print "chr: ", chr, "\n"
#       end
      ChipSeqDataset.merge_overlapping_regions(regions_arr)
    end
    max_seq_length = 0
    @sample_space.each do |chr, regions_arr|
      regions_arr.each do |r|
        max_seq_length = [max_seq_length, r.get_length()].max
      end
    end
#    print "max_seq_length = ", max_seq_length, "\n"
     
  end

     
  def construct_sample_space_using_another_dataset(id_of_dataset_to_use_for_sample_space)
    c = 0
    @sample_space = {}
    print "construct_sample_space_using_another_dataset\n", @datasets.keys.inspect, "\nsample_space_dataset: ", id_of_dataset_to_use_for_sample_space, "\n"
    sample_space_dataset = @datasets[id_of_dataset_to_use_for_sample_space]
    
    sample_space_dataset.dataset_seq_regions.each do |chr, regions_on_chr|
#        @sample_space[chr] = @sample_space[chr] + regions_on_chr
      regions_on_chr.each do |r|
        if(r.not_use_at_all_in_the_analysis == false)
          c += 1
          seq_id        = r.id
          score         = r.score
          start         = extract_start(seq_id)
          stop          = extract_stop(seq_id)
          strand        = "+"
          seq           = r.seq
          peak_location = r.peak_location
          args = {'id'=>seq_id,'chr'=>chr,'start'=>start,'stop'=>stop,'peak_location'=>peak_location,'strand'=>strand,'seq'=>seq,'score'=>score}
          seq_region = SeqRegion.new(args)
          if(@sample_space[chr] == nil)
            @sample_space[chr] = []
          end
          @sample_space[chr].push(seq_region)
        end
      end
    end
    print "done generating sample space using #{id_of_dataset_to_use_for_sample_space}: total number regions = #{c}\n"
    print "merging overlapping regions in sample space\n"
    @sample_space.each do |chr, regions_arr|
      print "chr: ", chr, "\n"
      ChipSeqDataset.merge_overlapping_regions(regions_arr)
    end
    max_seq_length = 0
    @sample_space.each do |chr, regions_arr|
      regions_arr.each do |r|
        max_seq_length = [max_seq_length, r.get_length()].max
      end
    end
    print "max_seq_length = ", max_seq_length, "\n"
  end

  
  # all regions "open" for p300 binding
  # seq_id assumed format: chr?:start_location-stop_location
  def construct_sample_space_combine_then_take_top_M(percentage_of_total)
    total = get_total_num_regions()
    k     = (percentage_of_total * total).to_i
    # to do...
  end
 
  def construct_sample_space_using_p300_open_regions()
    # to do...
  end
  
  def get_concat_dataset_ids()
#    print @datasets.keys.inspect
#    gets
    str = String.new(@datasets.keys[0])
    (1...@datasets.keys.length).each do |i|
      str<<"_"+String.new(@datasets.keys[i])
    end
    return str
  end
  
#  def DataProcessorCERMIT.test1(pars)
#    pars.each do |k,v|
#      if(k == "out_path")
#        DataProcessorCERMIT.init_out_path(v)
##        DataProcessorCERMIT.out_path = v
#      end
#      print k, "\t", v, "\n"
#    end
#    print DataProcessorCERMIT.input_params["out_path"], "\n"
#  end
  
  def output_all(hard_threshold_to_keep_from_top, name_prefix = "")
#    out_path = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/"+ @global_params["species"] +"/final/"
#    out_path = DataProcessorCERMIT.input_params["out_path"]+ @global_params["species"] + "/"
    out_path = @global_params["out_path"]+ @global_params["species"] + "/"
    
    
#    print "out_path = ", out_path, "\n"
    
    t = Timer.new()
    if(FileTest.exist?(@global_params["out_path"]) == false)
#      print "directory\n", @global_params["out_path"], "\ndoesn't exist. creating..."
      Dir.mkdir(@global_params["out_path"])
#      print "done\n"
    end
    
    # create output directories
    if(FileTest.exist?(out_path) == false)
#      print "directory\n", out_path, "\ndoesn't exist. creating..."
      Dir.mkdir(out_path)
#      print "done\n"
    end
    concat_dataset_ids = get_concat_dataset_ids()
    out_path = out_path + concat_dataset_ids + "/"
    if(FileTest.exist?(out_path) == false)
#      print "directory\n", out_path, "\ndoesn't exist. creating..."
      Dir.mkdir(out_path)
#      print "done\n"
    end
#    $stdin.gets
    
    print "extract sequence from .2bit' file...\n"
    @sample_space.sort{|a,b| a[0].to_i <=> b[0].to_i}.each do |chr, seq_regions_arr|
      print "chr ", chr,"\n"
#      SeqExtractor.extract_seq_from_chr_locations_default(seq_regions_arr, @global_params["species"])
#      print "DataProcessorCERMIT.input_params[2bitfile]:", DataProcessorCERMIT.input_params["2bitfile"], "\n"
#      $stdin.gets
    
      SeqExtractor.extract_seq_from_chr_locations(seq_regions_arr, @global_params["species"], @global_params["twobit_annotation_file"])
 #     SeqExtractor.extract_seq_from_chr_locations(seq_regions_arr, @global_params["species"], DataProcessorCERMIT.input_params["2bitfile"])
    end
    print "sequence extracted\n"

    @datasets.each do |dataset_id, dataset|
      if(dataset_id.scan("p300") != [])# or dataset_id.scan("DNase") != [])
        next
      end
#      print "outputting ", dataset_id, "\n"
      assign_dataset_specific_scores_to_sample_space(dataset)
#      print "dataset-specific scores assigned\n"
      t.print_time()
      
      # initialize a 'ChipSeqDataset' with @sample_space
      dataset.dataset_specific_parameters["regions_arr_initialization"] = true
      dataset.dataset_specific_parameters["regions_arr"] = @sample_space

      d = ChipSeqDataset.new(@global_params, dataset.dataset_specific_parameters)
    
      dataset.dataset_specific_parameters["regions_arr_initialization"] = false
      dataset.dataset_specific_parameters["regions_arr"] = nil

      min_max_length = "min_seq_length_"+@global_params["min_seq_length"].to_s+"_max_seq_length_"+@global_params["max_seq_length"].to_s + "_"
#      out_path_dataset = out_path + name_prefix + min_max_length + "/"

      if(@datasets.keys.length > 1)
        out_path_dataset = out_path + dataset_id + "_" + hard_threshold_to_keep_from_top.to_s + "/"
      else
        out_path_dataset = out_path  
      end
      
      if(FileTest.exist?(out_path_dataset) == false)
#        print "directory\n", out_path_dataset, "\ndoesn't exist. creating..."
        Dir.mkdir(out_path_dataset)
#        print "done\n"
      end
      
      @datasets.each do |dataset_id1, dataset1|
        @global_params["analyzed_datasets"].push(dataset_id1)
      end
      params_file = out_path_dataset + "params"
      f_out = File.open(params_file, "w")
      f_out.write("global parameters:\n"+@global_params.inspect+"\n")
      f_out.write("dataset-specific parameters:\n"+dataset.dataset_specific_parameters.inspect+"\n")
      f_out.close()
    
      d.create_cERMIT_input_and_run_files( @global_params["analyzed_datasets"], out_path_dataset, @global_params["known_pssm_path"])
      print "done\n"
      t.print_time()
    end
  end
  
  def assign_dataset_specific_scores_to_sample_space(dataset)
    print "assigning dataset-specific scores to #{@sample_space.values.flatten.length} regions in sample space..."
    num_assigned_non_zero = 0
    c1 = 0
#    print "total_num_regions = ", dataset.total_num_regions, "\n"
#    print "sample_space total_num_regions = ", @sample_space.values.flatten.length, "\n"
#    print "sample_space total_num_regions = ", sample_space_with_assigned_datasets_specific_scores.values.flatten.length, "\n"
    i=0
    
    @sample_space.each do |chr, regions_in_chr|
      regions_in_chr.each do |a|
        a.score = 0.0
        a.to_use_in_sample_space = true
      end
    end

    i = 0    
    dataset.dataset_seq_regions.each do |chr, regions_on_chr|
      if(@sample_space[chr] == nil)
        next
      end
      
      @sample_space[chr].each do |a|
        regions_on_chr.each do |r|
          if(r.to_use_in_sample_space == false)
            a.to_use_in_sample_space = false
            next
          end
          res_intersect = SeqExtractor.get_intersection(a.start, a.stop, r.start, r.stop)
          if(res_intersect != nil)
#            if(r.to_use_in_sample_space == false)
#              a.to_use_in_sample_space = false
#              next
#            end
            a.score = r.score
          end
        end
      end
    end
   
    print "done\n"
  end 
  
    
    
    
    
    
    
  def construct_sample_space_using_upstream_of_TSS(num_bp_upstream_of_TSS, num_bp_downstream_of_TSS, species)
    print "need to be modified!!!\n"
    gets
#    @upstream_mouse_regions_arr = read_Alan_upstream_regions_mouse()
    @sample_space = {}
#    sample_space_arr = SeqExtractor.read_Alan_input_upstream_regions_default()
    sample_space_arr = SeqExtractor.read_Alan_input_upstream_regions_default(num_bp_upstream_of_TSS, num_bp_downstream_of_TSS, species)
    sample_space_arr.each do |seq_region|
      if(@sample_space.keys.include?(seq_region.chr) == false)
        @sample_space[seq_region.chr] = []
      end
      @sample_space[seq_region.chr].push(seq_region)
    end    
  end

 
  def check_if_includes(seq_regions_arr, target_region_id)
    target_chr   = target_region_id.split(":")[0].split("chr")[1]
#    print "target_chr: ", target_chr,"\n"
    target_start = target_region_id.split(":")[1].split("-")[0].to_i
    target_stop  = target_region_id.split(":")[1].split("-")[1].to_i
    flag = false
    seq_regions_arr.each do |r|
      if(target_chr == r.chr)
        res_intersect = SeqExtractor.get_intersection(r.start,r.stop,target_start,target_stop)
        if(res_intersect != nil)
          print "includes: ",target_region_id,"\n", res_intersect.inspect,"\n"
          flag = true
        end
      end
    end
    if(flag == false)
      print "doesn't include: ",target_region_id,"\n"
    end
  end
      

  # helper routines
  def is_valid_global_params_input_line(line)
#     print line[0..0],"\n"
    return (line[0..0] != "#")
  end
  
  def is_valid_dataset_param_input_line(line)
    return (line[0..0] != "#" and line.split("\s").length == 4)
  end
  
  def extract_path(filename)
    tmp = filename.split("/")
    tmp.pop
    return tmp.join("/")+"/"     
  end

  
  def get_total_num_regions()
    total = 0
    @datasets.each do |id, dataset|
      total +=  dataset.total_num_regions
    end
    return total
  end

  # seq_id assumed format: chr?:start_location-stop_location
  def extract_chr(seq_id)
    return seq_id.split(":")[0].split("chr")[1].to_s
  end
  # seq_id assumed format: chr?:start_location-stop_location
  def extract_start(seq_id)
    return seq_id.split(":")[1].split("-")[0].to_i
  end
  # seq_id assumed format: chr?:start_location-stop_location
  def extract_stop(seq_id)
    return seq_id.split(":")[1].split("-")[1].to_i
  end
    
public

#  def DataProcessorCERMIT.run(species)
  def DataProcessorCERMIT.run()
#    parameters_file = ""
#    if(species == "mouse")
#      parameters_file = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/summary/cERMIT_parameters_file_mouse_new"
#    elsif(species =="human")
#      parameters_file = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/summary/cERMIT_parameters_file_human_new"
#    else
#      print "ERROR: DataProcessorCERMIT.run, species not supported: ", species,"\n"
#      gets
#    end
#    dp = DataProcessorCERMIT.new(parameters_file)
        
    dp = DataProcessorCERMIT.new(DataProcessorCERMIT.input_params["parameters_file"])
    
  #    print "num datasets = ", dp.datasets.length, "\n"
  #    gets
  end

  def DataProcessorCERMIT.create_sorted_score_files(in_dir)
    Dir.foreach(in_dir) do |file|
      if(FileTest.directory?(in_dir + file) == false and file.scan("score.out") != [] and file.scan("sorted") == [])
        out_file = in_dir + file +"_sorted"
        print file,"..."
        f_out = File.open(out_file,"w")
        f_out.write(IO.readlines(in_dir + file).sort {|a,b| b.split("\s")[1].to_f <=> a.split("\s")[1].to_f}.join(""))
        f_out.close()       
        print "done\n"
#        gets
      end
    end
  end


  def create_mouse_promoter_FASTA_file()
    in_file = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/mouse/Promoter_Regions/mouse_promoters.seq"
    out_file = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/mouse/Promoter_Regions/mouse_promoters.fasta"
    f_out = File.open(out_file,"w")
    IO.readlines(in_file).each do |l|
      arr = l.split("\s")
      id = arr[0]
      strand = arr[1]
      seq = arr[2]
      f_out.write(">"+id+":"+strand+"\n"+seq+"\n")
#      print id,"\n", seq
#      gets
    end
    f_out.close()
  end
 
  def create_mouse_promoter_cERMIT_format_seq_file()
    in_file = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/Promoter_Regions/mouse_promoters.seq"
    out_file = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/Promoter_Regions/mouse_promoters.cERMIT"
    f_out = File.open(out_file,"w")
    IO.readlines(in_file).each do |l|
      arr = l.split("\s")
      id = arr[0]
      strand = arr[1]
      seq = arr[2]
      f_out.write(seq+"$")
#      f_out.write(">"+id+":"+strand+"\n"+seq+"\n")
#      print id,"\n", seq
#      gets
    end
    f_out.close()
  end
  
#   def DataProcessorCERMIT.collect_data_Jose(in_dir, out_dir
#    f_out = File.open(out_file, "w")  
#    f_out.write("in_dir: "+in_dir+"\n\n")
#    print "main output directory: ", in_dir,"\n"
#    scores_top_cluster = {}
#    scores_ensemble = {}
#    Dir.foreach(in_dir) do |file|
##      print "dir: ", file,"\n"
#      if(FileTest.directory?(in_dir + file) == true and file.scan("..") == [])
#        sub_dir = in_dir + file + "/"
##        print "\tsub_dir: ", file, "\n"
#        Dir.foreach(sub_dir) do |file1|
#          if(FileTest.directory?(sub_dir + file1) == true and file1.scan("output") != [])
#            dir = sub_dir + file1 +"/"
##            print "\t\toutput dir: ", file1, "\n"
#            i = 1
#            Dir.foreach(dir) do |file2|
 
  
  def DataProcessorCERMIT.generate_summary(in_dir, out_file)
    f_out = File.open(out_file, "w")  
    f_out.write("in_dir: "+in_dir+"\n\n")
    print "main output directory: ", in_dir,"\n"
    scores_top_cluster = {}
    scores_ensemble = {}
    Dir.entries(in_dir).sort {|a,b| a.split("_")[0].to_i <=> b.split("_")[0].to_i}.each do |file|
#    Dir.foreach(in_dir) do |file|
      print "dir: ", file,"\n"
      if(FileTest.directory?(in_dir + file) == true and file.scan("..") == [])
        sub_dir = in_dir + file + "/"
#        print "\tsub_dir: ", file, "\n"
        Dir.entries(sub_dir).sort {|a,b| a.split("_")[0].to_i <=> b.split("_")[0].to_i}.each do |file1|
#        Dir.foreach(sub_dir).each do |file1|
          if(FileTest.directory?(sub_dir + file1) == true and file1.scan("output") != [] and file1.scan("scores_search") != [])
            dir = sub_dir + file1 +"/"
#            print "\t\toutput dir: ", file1, "\n"
            dataset = file1.split("search_").last
#            print sub_dir
#            gets
            i = 1
            Dir.entries(dir).sort {|a,b| a.split("_")[0].to_i <=> b.split("_")[0].to_i}.each do |file2|
#            Dir.foreach(dir) do |file2|

              max_score = 0
              tf = ""
              # check if ensemble PFM output file
              if(FileTest.directory?(dir + file2) == false and file2.scan("sim:") != [])
                tf = file2.split("cerv")[0].split("unmaskedseqfile_")[1]
                if(tf == nil)
                  tf = file2.split("_web_logo")[0].split("Human_").last.split(".")[0]
                else
                  tf = file2.split("cerv")[0].split("unmaskedseqfile_")[1].split(".")[0]
                end              
                score = file2.split("sim:")[1].split("_")[0].to_f
                scores_ensemble[tf] = score
#                print file2, "\tensemble score = ", score
#                gets
#                max_ensemble = [max_ensemble, score].max
              end
              
              if(FileTest.directory?(dir + file2) == false and file2.scan("summary") != [])
                tf = file2.split("cerv")[0].split("unmaskedseqfile_")[1]
                if(tf == nil)
                  tf = file2.split("_summary")[0].split("Human_").last.split(".")[0]
                else
                  tf = file2.split("cerv")[0].split("unmaskedseqfile_")[1].split(".")[0]
                end
#                print tf,"\n"
                suffix_to_output = dataset+"_cluster_"+tf+"\n"+"-------------------------\n"
#                print suffix_to_output,"\n"
                f_out.write(suffix_to_output+"\n")
#                print i, ":\t\t\t"+(dir + file2).split("/").last+"\n"
                i+=1
                lines = IO.readlines(dir + file2)
                num_lines_read = 0
                lines.each do |l1|
                  num_lines_read += 1
                  if(num_lines_read < 6)
                    next
                  end
                  l = l1
                  if(l.split("literature:").length == 2)
                    l = l.split("literature:")[0]+"\n"
                  end
                  if(l.scan(/^6/) != [])
                    f_out.write(l)
                    break
                  end
                  arr = l.split("\s")
#                  print arr.inspect
#                  gets
                  if(l.scan(/^known/) != [])
                    next
                  end
                  if(arr.length == 5 and arr[4].to_f.abs > 0)
                    max_score = [arr[4].to_f.abs, max_score].max
#                    print l, "max_score = ", max_score, "\n"
                  elsif(arr.length == 4 and arr[3].to_f.abs > 0)
                    max_score = [arr[3].to_f.abs, max_score].max
#                    print l, "max_score = ", max_score, "\n"
                  end
                  f_out.write(l)
                end
#                gets
                f_out.write("\n")
                scores_top_cluster[tf] = max_score
              end
            end
          end
        end
      end
    end
    
    f_out.write("top scoring motifs:\n")
    scores_top_cluster.sort{|a,b| b[1].to_f <=> a[1].to_f}.each do |arr|
      f_out.write(arr[0]+"\t"+arr[1].to_s+"\n")
    end
    f_out.close()
    
    

    threshold = 0.75
    num_datasets = scores_top_cluster.length
#    print "scores_top_cluster:\n", scores_top_cluster.inspect, "\n"
#    print "scores_ensemble:\n", scores_ensemble.inspect, "\n"

    print "scores_top_cluster:"
    c = 0
#    scores_top_cluster.values.sort{|a,b| b.to_f <=> a.to_f}.each do |s|
    scores_top_cluster.sort{|a,b| b[0] <=> a[0]}.each do |arr|
      s  = arr[1].to_f
      tf = arr[0]
      if(s.to_f >= threshold)
        c+=1
        print "\t", tf, ": ", s
      end
    end
    print "\nscores_ensemble:"
    c_ens = 0
    scores_ensemble.sort{|a,b| b[0] <=> a[0]}.each do |arr|
#    scores_ensemble.values.sort{|a,b| b.to_f <=> a.to_f}.each do |s|
      s  = arr[1].to_f
      tf = arr[0]
      if(s.to_f >= threshold)
        c_ens+=1
#        print "\t",  s
        print "\t", tf, ": ", s
      end
    end
    print "\n"
    
    all_tfs = {}
    scores_top_cluster.each do |k,v|
      if(v.to_f >= threshold)
        all_tfs[k] = v
      end
    end
    
    ens_tf = {}
    scores_ensemble.each do |k,v|
      if(v.to_f >= threshold)
        ens_tf[k] = v
      end
    end
    
    print "all_tfs:\n", all_tfs.sort{|a,b| b[1].to_f <=> a[1].to_f}.inspect,"\n"
    print "ens_tf:\n", ens_tf.sort{|a,b| b[1].to_f <=> a[1].to_f}.inspect,"\n"
    
    print "intersection = ", (all_tfs.keys & ens_tf.keys).length, "\n"
  
#    print scores_top_cluster.inspect,"\n"
    print "# scores_top_cluster above threshold = ", c," out of #{num_datasets}\n"
    print "# scores_ensemble above threshold = ", c_ens," out of #{num_datasets}\n"

#    if(FileTest.exist?(out_path) == false)
  end
  
  def DataProcessorCERMIT.create_batch_input_file_yeast_chip_chip(input_file_dir = nil)  
    in_file  = "/home/sgg4/workspace_64bit/GMF_05_10_2008/run_file_cerv_bay_mik_par_kud_union"
    out_file = in_file+"_processed1"
    f_out = File.open(out_file, "w")
    IO.readlines(in_file).each do |l|
      arr         = l.strip.split("\s")
      excutable   = "/nfs/labs/compbio/ohler/pubs/Georgiev08/cERMIT/Jan_2009/cERMIT_SAu"
      output_dir  = "output_chip_chip_cerv_only"
      output_line = "" 
      if(input_file_dir == nil)
        output_line = excutable + " "+arr[1] + " " + arr[2] + " " + output_dir + " chip_chip"+ "\n"
      else
        output_line = excutable + " "+input_file_dir+arr[1].split("/").last + " " + input_file_dir+ arr[2].split("/").last + " " + output_dir + " chip_chip"+ "\n"
      end
      f_out.write(output_line)
    end
    f_out.close()
  end

  def DataProcessorCERMIT.test_generate_summary()
#    in_dir = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/new_peaks0313/final/Sox2_Nanog_Zfx_Oct4_p300_Tcfcp2I1_E2f1_n-Myc_Klf4_Esrrb_cMyc_STAT3_Smad1/"
#    in_dir = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/new_peaks0313/final/Sox2_Nanog_Zfx_Oct4_p300_Tcfcp2I1_E2f1_n-Myc_Klf4_Esrrb_cMyc_STAT3/analyzed/"
#     in_dir = "/nfs/labs/compbio/ohler/pubs/Georgiev0807/GMF/microRNA/5_mers/Rajewski_mRNA_32hr/output_chip_chip/"

#    in_dir = "/research/labs/ohlerlab/sata/data/sgeorg/chipSeq/human/final/Human_STAT1_Human_FoxA1_Human_CTCF_Human_GABP_Human_NRSF_Human_SRF/top_5000_final/"
#    in_dir = "/research/labs/ohlerlab/sata/data/sgeorg/chipSeq/human/final/DNase_final/final/"
#     in_dir = "/research/labs/ohlerlab/sata/data/sgeorg/chipSeq/mouse/final/MouseES_CTCF_MouseES_Oct4_MouseES_Zfx_MouseES_Tcfcp2I1_MouseES_Sox2_MouseES_nMyc_MouseES_p300_MouseES_cMyc_MouseES_E2f1_MouseES_Nanog_MouseES_Esrrb_MouseES_STAT3_MouseES_Klf4_working/top_2000_100_to_1000/"
#     in_dir ="/research/labs/ohlerlab/sata/data/sgeorg/chipSeq/human/final/Human_STAT1_Human_FoxA1_Human_CTCF_Human_GABP_Human_NRSF_Human_SRF/top_10000_final/"
     in_dir = "/research/labs/ohlerlab/sata/data/sgeorg/Jose/cERMIT_input_final/"

#    in_dir = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/new_peaks0313/final/max_length_500_top_10000/Sox2_Nanog_Zfx_Oct4_p300_Tcfcp2I1_E2f1_n-Myc_Klf4_Esrrb_cMyc_STAT3_Smad1/"
#    in_dir = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/new_peaks0313/final/max_length_500_top_5000/Sox2_Nanog_Zfx_Oct4_p300_Tcfcp2I1_E2f1_n-Myc_Klf4_Esrrb_cMyc_STAT3_Smad1/"
#    in_dir = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/new_peaks0313/final/max_length_1500_top_5000/Sox2_Nanog_Zfx_Oct4_p300_Tcfcp2I1_E2f1_n-Myc_Klf4_Esrrb_cMyc_STAT3_Smad1/"
#    in_dir = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/new_peaks0313/final/seq_length_100_to_1000_top_5000/"
#    out_file = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/new_peaks0313/final/seq_length_100_to_1000_top_5000/summary_all"
    out_file = in_dir + "summary_all"
    DataProcessorCERMIT.generate_summary(in_dir, out_file)
  end

# end of class
end

def parse_ARGV()
  pars = {}
  ARGV.each do |a|
#    print a.inspect, "\n"
    pars[a.split("=")[0]] = a.split("=")[1]
  #  if(a.split("=")[0] == "out_path")
  #    DataProcessorCERMIT.init_out_path(a.split("=")[1])
  #  elsif(a.split("=")[0] == "in_path")
  #    DataProcessorCERMIT.init_in_path(a.split("=")[1])
  #  end
  end
#  print pars.inspect
#  $stdin.gets
  return pars
end
pars = parse_ARGV()
DataProcessorCERMIT.init_input_paramteres(pars)

#DataProcessorCERMIT.test1(pars)

#species = "human"#"mouse"#
#DataProcessorCERMIT.run(species)
#print "\n"
DataProcessorCERMIT.run()


#in_dir = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/mouse/"
#DataProcessorCERMIT.create_sorted_score_files(in_dir)

#DataProcessorCERMIT.test_generate_summary()

#input_file_dir = "/research/labs/compbio/ohler/pubs/Georgiev0807/Xuan/gmf_stuff/gmf_conservation/newbaapunion/cerv_cerv_cervcons/"
#DataProcessorCERMIT.create_batch_input_file_yeast_chip_chip(input_file_dir)  

#load("/home/sgg4/ruby_ws/gene_sets/DataProcessorCERMIT.rb")