
#load("/nfs/central/home/sgg4/ruby_ws/gene_sets/Timer.rb") 
#load("/home/sgg4/ruby_ws/gene_sets/SeqRegion.rb")
load("Timer.rb") 
load("SeqRegion.rb")


class SeqExtractor
  
#  attr_reader :gene_hash
  def initialize(twobit_format_sequence_file, twoBitGrab_path)
    @sequence_twobit_filename = twobit_format_sequence_file
    @twoBitGrab_path          = twoBitGrab_path
#    print "using: #{@twoBitGrab_path}#{@sequence_twobit_filename}\n"
#    gets
  end

###################
# PUBLIC routines #
###################
public

  def read_Alan_input_upstream_regions_and_extract_seq_from_genome(input_file)
    ids_arr = []
    seq_regions = []
    lines = IO.read(input_file)
    t = Timer.new()
    lines.each do |l|
      arr    = l.strip.split("\s")
      id     = arr[0]
      if(ids_arr.include?(id) == true)
        read_seq_flag = false
        next
      end
      ids_arr.push(id)  
      chr    = id.split(":")[0].split("chr")[1]
      start  = id.split(":")[1].split("-")[0].to_i
      stop   = id.split(":")[1].split("-")[1].to_i
      strand = arr[1]
      peak_location = (start + stop) / 2
      args = {'id'=>id,'chr'=>chr,'start'=>start,'stop'=>stop,'peak_location'=>peak_location,'strand'=>strand,'seq'=>nil,'score' => 0.0}
      region = SeqRegion.new(args)
      seq_regions.push(region)
    end
#    print seq_regions.length,"\n"
    t.print_time()
#    print "data input read\n"
     extract_seq_from_chr_locations(seq_regions)
#    print regions_arr.length,"\n"
    return seq_regions
  end
  
  def read_Alan_input_upstream_regions(input_file)
    ids_arr = []
    seq_regions = []
    lines = IO.read(input_file)
    t = Timer.new()
    lines.each do |l|
      arr    = l.strip.split("\s")
      id     = arr[0]
      if(ids_arr.include?(id) == true)
        read_seq_flag = false
        next
      end
      ids_arr.push(id)  
      chr    = id.split(":")[0].split("chr")[1]
      start  = id.split(":")[1].split("-")[0].to_i
      stop   = id.split(":")[1].split("-")[1].to_i
      peak_location = (start + stop) / 2
      strand = arr[1]
      seq    = arr[2].upcase.gsub("N", "X")
      args = {'id'=>id,'chr'=>chr,'start'=>start,'stop'=>stop,'peak_location'=>peak_location,'strand'=>strand,'seq'=>seq,'score' => 0.0}
      region = SeqRegion.new(args)
      seq_regions.push(region)
    end
#    print seq_regions.length,"\n"
#    t.print_time()
#    print "data input read\n"
#    print seq_regions.length,"\n"
    return seq_regions
  end
  
#  def SeqExtractor.crop_sequence(regions_arr, remove_from_start, remove_from_end)
# assumed alan format: 4KB--TSS--2KB
  def SeqExtractor.crop_sequence(regions_arr, num_bp_upstream_of_TSS, num_bp_downstream_of_TSS)
    regions_arr.each do |r|
#      print "r.seq_length = ", r.seq_length,"\n"
#      r.show_loc()   
      seq_length  = r.seq_length
      if(r.strand == "+")
        start_index   = 4000 - num_bp_upstream_of_TSS
        end_index     = 4000 + num_bp_downstream_of_TSS
        new_chr_start = r.start + start_index
        new_chr_stop  = r.stop  - (2000 - num_bp_downstream_of_TSS)
        r.set_id_and_location_info(r.chr, new_chr_start, new_chr_stop)
        r.peak_location = (new_chr_start + new_chr_stop) / 2
      else 
        # r.strand == "+"
        start_index   = 2000 - num_bp_downstream_of_TSS
        end_index     = 2000 + num_bp_upstream_of_TSS
        new_chr_start = r.start + start_index
        new_chr_stop  = r.stop  - (4000 - num_bp_downstream_of_TSS)
        r.set_id_and_location_info(r.chr, new_chr_start, new_chr_stop)
        r.peak_location = (new_chr_start + new_chr_stop) / 2
      end
#      start_index = remove_from_start
#      end_index   = seq_length - remove_from_end
      new_seq = r.seq.slice(start_index...end_index)
      r.seq = new_seq
#      r.set_id_and_location_info(r.chr, r.start + start_index, r.stop-remove_from_end)
#      print "r.seq_length = ", r.seq_length,"\n"
#      r.show_loc()
#      gets
    end
  end

  def SeqExtractor.read_Alan_input_upstream_regions_default(num_bp_upstream_of_TSS, num_bp_downstream_of_TSS, species)
#    human_annotation_file = "/nfs/furey_fc/gbdb/hg18/hg18.2bit"
    human_annotation_file = "/nfs/labs/ohlerlab/sata/data/sgeorg/gbdb/hg18.2bit"
    
#    mouse_annotation_file = "/nfs/furey_fc/gbdb/mm9/mm9.2bit"
    mouse_annotation_file = "/nfs/labs/ohlerlab/sata/data/sgeorg/gbdb/mm9.2bit"

    annotation_file = ""
    input_file      = ""
    if(species == "mouse")
      input_file      = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/Promoter_Regions/mouse_promoters.seq"
      annotation_file = mouse_annotation_file
    elsif(species == "human")
      annotation_file = human_annotation_file
      input_file      = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/new_peaks0313/human_promoters.seq"
    else
      print "ERROR: SeqExtractor.read_Alan_input_upstream_regions_default, unsupported species: , ", species, "\n"
      gets
    end
    twoBitGrab_path = "/home/sgg4/seq_retrieval/"
    s               = SeqExtractor.new(annotation_file, twoBitGrab_path)
#    input_file      = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/Promoter_Regions/mouse_promoters.seq"
#    input_file      = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/new_peaks0313/human_promoters.seq"
#    input_file        = "/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/Promoter_Regions/mouse_promoters2KB.seq"
    
    regions_arr       = s.read_Alan_input_upstream_regions(input_file)
    print "regulatory region: ", num_bp_upstream_of_TSS, "bp upstream\t", num_bp_downstream_of_TSS, "bp downstream\n"
#    remove_from_start = 2000
#    remove_from_end   = 2000
    SeqExtractor.crop_sequence(regions_arr, num_bp_upstream_of_TSS, num_bp_downstream_of_TSS)
#    f_out = File.open("/nfs/labs/ohlerlab/sata/data/sgeorg/chipSeq/3mouse_ES/Promoter_Regions/mouse_promoters2KB.seq", "w")
#    regions_arr.each do |r|
#      f_out.write(r.id+"\t"+r.strand+"\t"+r.seq+"\n")
#    end
#    f_out.close()
    return regions_arr
  end

  # seq_regions (array) -> [seq_region1, seq_region2,...]
  def extract_seq_from_chr_locations(seq_regions_arr)
    tmp_bed_file = "tmp_bed_file.bed"
    
    seq_region_arr = []
    create_bed_file(seq_regions_arr, tmp_bed_file)
    tmp_fasta_file = "tmp_fasta_file.fa"
    
    print "bedfile created: ", seq_regions_arr.length," regions \n"
#    gets

#    t = Timer.new()

#   call Molly's perl script 
    command   = @twoBitGrab_path + "twoBitGrab.pl "+tmp_bed_file+" "+@sequence_twobit_filename+" "+tmp_fasta_file
    system(command)

    # remove temporary .bed file
    if(FileTest.exist?(tmp_bed_file) == true)
      command = "rm " + tmp_bed_file
      system(command)
    end
  
    read_extracted_fasta_seq_data(tmp_fasta_file, seq_regions_arr)
    print "sequences extracted into FASTA file\n"
    
    # remove temporary .fa file
    if(FileTest.exist?(tmp_fasta_file) == true)
      command = "rm " + tmp_fasta_file
      system(command)
    end
  end
  
  def SeqExtractor.write_seq_to_file(seq_regions_arr, out_file)
    f_out = File.open(out_file, "w")
    seq_regions_arr.each do |region|
      if(region.start == region.stop)
        print "ERROR:, 'write_seq_to_file', start == stop\n"
        gets
      end
      f_out.write(region.id + "\t"+region.seq+"\n")     
    end
    f_out.close()      
  end
  
  
  def parse_arab()
    in_file = "/research/labs/ohlerlab/sata/data/sgeorg/Arabidopsis/genome2bit/TAIR9_GFF3_genes.gff"
    IO.readlines(in_file).each do |l|
      print l
      gets
    end
  end
#  def SeqExtractor.read_seq_from_file(in_file)
#    seq_regions_arr = []
#    File.open(in_file, "r").each do |l|
#      arr = l.strip.split("\s")
#      seq_id  = arr[0]
#      seq     = arr[1]
#      score = 0.0
#      chr           = ChipSeqDataset.extract_chr(seq_id)
#      start         = ChipSeqDataset.extract_start(seq_id)
#      stop          = ChipSeqDataset.extract_stop(seq_id)
#      peak_location = arr_scores[2].to_i
#      strand        = "+"
#      
#      args = {'id'=>seq_id,'chr'=>chr,'start'=>start,'stop'=>stop,'peak_location'=>peak_location,'strand'=>strand,'seq'=>seq,'score'=>score}
#
#    end
#    return seq_regions_arr
#  end
#  
#
#    seq_regions_arr.each do |region|
#      if(region.start == region.stop)
#        print "ERROR:, 'write_seq_to_file', start == stop\n"
#        gets
#      end
#      f_out.write(region.id + "\t"+region.seq+"\n")     
#    end
#    f_out.close()      
#  end

  def SeqExtractor.extract_seq_from_chr_locations(seq_regions_arr, species, annotation_file)
   
##    human_annotation_file = "/nfs/furey_fc/gbdb/hg18/hg18.2bit"
#    human_annotation_file = "/nfs/labs/ohlerlab/sata/data/sgeorg/gbdb/hg18.2bit"
##    mouse_annotation_file = "/nfs/furey_fc/gbdb/mm9/mm9.2bit"
#    mouse_annotation_file = "/nfs/labs/ohlerlab/sata/data/sgeorg/gbdb/mm9.2bit"
#    annotation_file = ""
##    print "species = ", species,"\n"
#    if(species == "human")
#      annotation_file = human_annotation_file
#    elsif(species == "mouse")
#      annotation_file = mouse_annotation_file
#    else
#      print "ERROR: species not supported: ", species,"\n"
#      gets
#    end
#    twoBitGrab_path       = "/home/sgg4/seq_retrieval/"
#    print "annotation_file = ", annotation_file, "\n"
#    $stdin.gets
    twoBitGrab_path       = "./"
    s = SeqExtractor.new(annotation_file, twoBitGrab_path)
    s.extract_seq_from_chr_locations(seq_regions_arr)
  end


  def SeqExtractor.extract_seq_from_chr_locations_default(seq_regions_arr, species)
   
#    human_annotation_file = "/nfs/furey_fc/gbdb/hg18/hg18.2bit"
    human_annotation_file = "/nfs/labs/ohlerlab/sata/data/sgeorg/gbdb/hg18.2bit"
#    mouse_annotation_file = "/nfs/furey_fc/gbdb/mm9/mm9.2bit"
    mouse_annotation_file = "/nfs/labs/ohlerlab/sata/data/sgeorg/gbdb/mm9.2bit"
    annotation_file = ""
#    print "species = ", species,"\n"
    if(species == "human")
      annotation_file = human_annotation_file
    elsif(species == "mouse")
      annotation_file = mouse_annotation_file
    else
      print "ERROR: species not supported: ", species,"\n"
      gets
    end
    twoBitGrab_path       = "/home/sgg4/seq_retrieval/"
    s = SeqExtractor.new(annotation_file, twoBitGrab_path)
    s.extract_seq_from_chr_locations(seq_regions_arr)
  end

  def extract_sequence_bedfile_input(bed_file) 
  # location_info[region_id][chr, start, stop]
    regions_arr = read_bed_file(bed_file)
#    print "regions_arr.length = ", regions_arr.inspect, "\n"
#    gets
    extract_seq_from_chr_locations(regions_arr)
    return regions_arr
  end
  
  # assume on same chromosome
  def SeqExtractor.overlap?(start1, stop1, start2, stop2)
    len1 = stop1 - start1 + 1
    len2 = stop2 - start2 + 1
    leftmost  = [start1, start2].min 
    rightmost = [stop1, stop2].max 
  
    # overlap condition
    if(rightmost - leftmost < len1 + len2)
      # ovelap by at lest one base
      return true
    else
      # don't overlap
      return false
    end
  end
  
  def SeqExtractor.get_intersection(start1, stop1, start2, stop2)
    left_intersect  = [start1, start2].max 
    right_intersect = [stop1 , stop2 ].min 
  
    # overlap condition
    if(right_intersect - left_intersect > 0)
      # ovelap by at lest one base
      return [left_intersect, right_intersect]
    else
      # don't overlap
      return nil
    end
  end
  
  def SeqExtractor.get_union(start1, stop1, start2, stop2)
    len1 = stop1 - start1 + 1
    len2 = stop2 - start2 + 1
    left_union  = [start1, start2].min 
    right_union = [stop1 , stop2 ].max 
  
    # overlap condition
    if(right_union - left_union < len1 + len2)
      # ovelap by at lest one base
      return [left_union, right_union]
    else
      # don't overlap
      return nil
    end
  end 

  # target_regions_info[seq_id][chr, start, stop]
  # all_regions[seq_id][chr, start, stop]
  def SeqExtractor.find_intersecting_regions(regions_database_arr, target_regions_arr)
    intersecting_regions = {}   
    target_regions_arr.each do |region1|
      chr1   = region1.chr
      start1 = region1.start
      stop1  = region1.stop
      regions_database_arr.each do |region2|
        chr2   = region2.chr
        start2 = region2.start
        stop2  = region2.stop
        if(chr1 == chr2)
          if(overlap?(start1, stop1, start2, stop2) == true)
            if(intersecting_regions.keys.include?(region1.id) == false)
              intersecting_regions[region1.id] = []
            end
            regions_info = {}
            regions_info[region2.id] = [chr2, start2, stop2]
            intersecting_regions[region1.id].push(regions_info)
          end
        end
      end
    end
    # intersecting_regions[seq_id] = [region1_info, region2_info,...]
    # region1_info[seq_id] = [chr, start, stop]
    return intersecting_regions
  end
###############
# TEST routines
###############
  
  def test_extract_region_info()
    region = ">label_2 0 - chr3  52552279_52554279"
    id = extract_id(region)#send(extract_region_info["id"], region)
    chr = extract_chr(region)#send(extract_region_info["chr"], region)
    start = extract_start(region)#send(extract_region_info["start"], region)
    stop = extract_stop(region)#send(extract_region_info["stop"], region)
    print [id, chr, start, stop].inspect,"\n"
  end
   
  def test_create_bed_file()
    data = {}
    data["label_1"] = [3,42552279,42554279]
    data["label_2"] = [3,52552279,52554279]
    
    id1 = "label11"; chr1 = "1"; start1 =  55; stop1 =  2; strand1 = "+"
    id2 = "label22"; chr2 = "3"; start2 = 555; stop2 = 11; strand2 = "-"
    id3 = "label33"; chr3 = "2"; start3 = 555; stop3 = 11; strand3 = "-"
    peak_location1 = (start1+stop1) / 2
    peak_location2 = (start2+stop2) / 2
    peak_location3 = (start3+stop3) / 2
    
    args1 = {'id'=>id1,'chr'=>chr1,'start'=>start1,'stop'=>stop1,'peak_location'=>peak_location1,'strand'=>strand1,'seq'=>nil,'score' => 0.0}
    args2 = {'id'=>id2,'chr'=>chr2,'start'=>start2,'stop'=>stop2,'peak_location'=>peak_location2,'strand'=>strand2,'seq'=>nil,'score' => 0.0}
    args3 = {'id'=>id3,'chr'=>chr3,'start'=>start3,'stop'=>stop3,'peak_location'=>peak_location3,'strand'=>strand3,'seq'=>nil,'score' => 0.0}

    r1 = SeqRegion.new(args1)
    r2 = SeqRegion.new(args2)
    r3 = SeqRegion.new(args3)

    seq_region_arr = [r1,r2, r3]
    out_file = "/home/sgg4/alok/test_extract_seq1"
    create_bed_file(seq_region_arr, out_file)
  end

  def test_find_intersecting_regions()
    bed_file = "/home/sgg4/alok/LHSRAR_nodrug.bed"
    id1 = "label11"; chr1 = "1"; start1 =  55; stop1 =  2; strand1 = "+"
    id2 = "label22"; chr2 = "3"; start2 = 555; stop2 = 11; strand2 = "-"
    id3 = "label33"; chr3 = "2"; start3 = 555; stop3 = 11; strand3 = "-"
    peak_location1 = (start1+stop1) / 2
    peak_location2 = (start2+stop2) / 2
    peak_location3 = (start3+stop3) / 2
    
    args1 = {'id'=>id1,'chr'=>chr1,'start'=>start1,'stop'=>stop1,'peak_location'=>peak_location1,'strand'=>strand1,'seq'=>nil,'score' => 0.0}
    args2 = {'id'=>id2,'chr'=>chr2,'start'=>start2,'stop'=>stop2,'peak_location'=>peak_location2,'strand'=>strand2,'seq'=>nil,'score' => 0.0}
    args3 = {'id'=>id3,'chr'=>chr3,'start'=>start3,'stop'=>stop3,'peak_location'=>peak_location3,'strand'=>strand3,'seq'=>nil,'score' => 0.0}

    r1 = SeqRegion.new(args1)
    r2 = SeqRegion.new(args2)
    r3 = SeqRegion.new(args3)

    database_regions_arr = read_bed_file(bed_file)
    target_regions_arr = [r1,r2,r3,database_regions_arr[0],database_regions_arr[34]]
    
    print database_regions_arr.length,"\n"
#    print target_regions_arr.length,"\n"

    intersecting_regions = SeqExtractor.find_intersecting_regions(database_regions_arr, target_regions_arr)
    print intersecting_regions.inspect, "\n"
  end
  
  def test_extract_sequence_bedfile_input()
    bed_file = "/home/sgg4/alok/tmp_bed_file.bed"
    regions = extract_sequence_bedfile_input(bed_file)
    regions.each do |r|
      r.show()  
    end
  end

  def SeqExtractor.test_extract_sequence_bedfile_input_default()
#    mouse_annotation_file = "/nfs/labs/ohlerlab/sata/data/sgeorg/gbdb/mm9.2bit"
    mouse_annotation_file = "/nfs/furey_fc/gbdb/mm9/mm9.2bit"
    twoBitGrab_path       = "/home/sgg4/seq_retrieval/"
    s = SeqExtractor.new(mouse_annotation_file, twoBitGrab_path)
    s.test_extract_sequence_bedfile_input()
  end

##################
# PRIVATE routines
##################
private
  # extracting from Molly's script's output 
  # format: >id1 0 - chr6  10000_10100
  def extract_id(id_line)
    return id_line.split("\s")[0].split(">")[1]
  end
  def extract_chr(region_id)
    return region_id.split("\s")[1].split("chr")[1].to_s
  end
  def extract_start(region_id)
    return region_id.split("\s")[2].split("_")[0].to_i
  end
  def extract_stop(region_id)
    return region_id.split("\s")[2].split("_")[1].to_i
  end
  def extract_strand(region_id)
     return region_id.split("\s")[3]
  end
  
  # data[seq_id][chr, start, stop]
  def create_bed_file(seq_region_arr, out_file)
    f_out = File.open(out_file, "w")
    seq_region_arr.sort{|a,b| a.chr <=> b.chr}.each do |seq_region|
      line = "chr"+seq_region.chr+"\t"+seq_region.start.to_s+"\t"+seq_region.stop.to_s+"\t"+seq_region.id+"\t"+"0"+"\t"+seq_region.strand+"\n"
      f_out.write(line)
    end
    f_out.close()
  end

  # regions_info[region_id][chr, start, stop]
  def read_bed_file(bed_file)
    lines = IO.readlines(bed_file)
    
    # if file was saved under Windows need to replace '\r' with '\n'
    if(lines.length == 1)
      lines = lines[0].gsub("\r","\n")
    end
    
    regions_arr = []
#    regions_info = {}
    lines.each do |l|
      arr    = l.strip.split("\s")
      chr    = arr[0].split("chr")[1]
      start  = arr[1].to_i
      stop   = arr[2].to_i
      id     = arr[3]
      strand = arr[5]
#      score = arr[3].to_f
      id = chr+":"+start.to_s+"-"+stop.to_s
#      regions_info[id] = [chr, start, stop]
      peak_location = (start + stop) / 2
      args = {'id'=>id,'chr'=>chr,'start'=>start,'stop'=>stop,'peak_location'=>peak_location,'strand'=>strand,'seq'=>nil,'score' => 0.0}
      seq_region = SeqRegion.new(args)
      regions_arr.push(seq_region)
#      print regions_info[id].inspect
#      gets
    end
    return regions_arr
  end
  
  #>id1 0 - chr6  10000_10100
  def read_extracted_fasta_seq_data(in_file, regions_arr)
    lines = IO.read(in_file)
    index = 0
    found_flag = false
    c = 0
    lines.each do |l|
      if(l.scan(">") != [])
        chr       = extract_chr(l)
        start     = extract_start(l)
        stop      = extract_stop(l)
        (0...regions_arr.length).each do |i|
          if(regions_arr[i].stop == stop and regions_arr[i].start == start and regions_arr[i].chr == chr)
            index = i
            regions_arr[index].seq_length = stop - start
#        seq_id = "chr"+chr+":"+start.to_s+"-"+stop.to_s
            regions_arr[index].seq = ""
#            regions_arr[index].set_seq("")
            found_flag = true
            break
          end
        end
      else
        if(found_flag == true)
          regions_arr[index].seq<<l.strip.upcase.gsub("N", "X")
          found_flag = false
        else
          print "ERROR: region not found\n"
#          regions_arr[index] = nil
#          gets
          c+=1
        end
      end
    end
    if(c > 0)
      print "failed to extract #{c} region(s)\n"
      regions_arr.compact!
#      gets
    end
  end
    
# end of class
end
#SeqExtractor.test_extract_sequence_bedfile_input_default()

#SeqExtractor.read_Alan_input_upstream_regions_default()
#load("/home/sgg4/ruby_ws/gene_sets/SeqExtractor.rb")
