#class Feature
#  attr_reader :id, :chr, :start, :stop, :strand, :seq
#  def initialize(seq_region, score)
#  
#end

#lines = IO.read("/home/sgg4/Desktop/main_project/data/RIP_CHIP/Pat_Brown/ids_raw_rip_chip")
#h = {}
#lines.each do |l|
#  if(h.keys.include?(l.split("_")[0]) == false)
#    h[l.split("_")[0]] = 0
#  end
#  h[l.split("_")[0]] += 1
#end
#load("/nfs/central/home/sgg4/ruby_ws/gene_sets/SeqExtractor.rb")


#load("/nfs/central/home/sgg4/ruby_ws/gene_sets/BasicStats.rb")
load("BasicStats.rb")


class SeqRegion
  attr_reader :id,:chr,:start,:stop,:strand,:seq,:score,:peak_location,:seq_length,:original_start,:original_stop,:to_use_in_sample_space,:not_use_at_all_in_the_analysis
  attr_writer :score,:seq,:peak_location,:seq_length,:to_use_in_sample_space,:not_use_at_all_in_the_analysis

#  def initialize(args)
#    print args["b"], "\n"
#    print args["id"], "\n"
#    print args["c"], "\n"
#    gets
#  end
  def initialize(args)
#id = "dummy_id", chr = "X", start = 10, stop = 20, peak_location = 15, strand = "+", seq = nil, score = 0.0
    @id            = args["id"].to_s
    @chr           = args["chr"].to_s
    @start         = args["start"].to_i
    @stop          = args["stop"].to_i
    @peak_location = args["peak_location"].to_i
    @strand        = args["strand"].to_s
    @seq           = args["seq"]
    @score         = args["score"].to_f
    if(@seq == nil)
      if(@start != nil and @stop != nil)
        @seq_length    = @stop - @start
      end
    else
      @seq_length = @seq.length
    end    
    @converted_to_cERMIT_format_flag = false
    @original_start = nil
    @original_stop  = nil
    @to_use_in_sample_space = true
    @not_use_at_all_in_the_analysis = false
  end

#  def initialize(id = "dummy_id", chr = "X", start = 10, stop = 20, peak_location = 15, strand = "+", seq = nil, score = 0.0)
#
#    @id            = id.to_s
#    @chr           = chr.to_s
#    @start         = start.to_i
#    @stop          = stop.to_i
#    @peak_location = peak_location.to_i
#    @strand        = strand.to_s
#    @seq           = seq
#    @score         = score.to_f
#  end
  
public

  def compare_loc(target_region)
    if(@chr > target_region.chr)
      return 1
    elsif(@chr < target_region.chr)
      return -1  
    else
      if(@start < target_region.start)
        return -1
      elsif(@start > target_region.start)
        return 1
      else
        return 0
      end 
    end
  end
  
  def set_original_location_info(start, stop)
    @original_start = start
    @original_stop  = stop
  end

  # GET/SET methods
  def set_id_and_location_info(chr, start, stop, id="")
    @chr   = chr
    @start = start
    @stop  = stop
    @seq_length = @stop - @start
    if(id == "")
      @id = "chr"+chr+":"+start.to_s+"-"+stop.to_s
    else
      @id = id    
    end
#    show_loc()
  end  
  
  def get_length()
    return @stop-@start
  end
    
  def get_data()
    return [@id, @chr, @start, @stop, @strand, @seq, @score]
  end
  
  def get_in_bed_format()
    str = "chr"+@chr+"\t"+@start.to_s+"\t"+@stop.to_s+"\t"+@id+"\t"+"0"+"\t"+@strand
    return str
  end
  
  def get_cERMIT_format(max_seq_length)
    if(@seq != nil)
#      if(@seq.length == 2*max_seq_length + 2)
#        return @seq
#      end
#      if(@seq_length != @seq.length)
#        print "ERROR: 'get_cERMIT_format', @seq.length != @seq_length: ", @seq.length, "\t", @seq_length, "\n"
#        gets
#      end
#      @seq.gsub!(/[^AGCT]/, 'X')
      seq_to_append = 'X'*(max_seq_length - @seq_length)
#      @seq = @seq + seq_to_append+"$"+rev_complement_proc(@seq + seq_to_append)+"$"
#      @seq_length = @seq.length
#      return @seq
      cERMIT_seq = @seq + seq_to_append+"$"+rev_complement_proc(@seq + seq_to_append)+"$"
      return cERMIT_seq
#      @seq<<seq_to_append
#      return @seq+"$"+rev_complement_proc(@seq)+"$"
    else
      print "ERROR: class SeqRegion, @seq not initilaized!\n"
      species = "mouse"
      SeqExtractor.extract_seq_from_chr_locations_default([self], species)
      print "extracted\n"
      gets
      return get_cERMIT_format(max_seq_length)
    end    
  end
  
  def test_remove_garbage_symbols()
    a = "AASTNGCT"
    print a.gsub(/[^AGCT]/, 'X')
  end

  # DISPLAY methods
  def show()
    print "chr", @chr, "\t", @start, "\t", @stop, "\t", @peak_location, "\t", @id, "\t"+"0"+"\t", @strand,"\t", @score, "\t"
    if(seq != nil)
      print  @seq
    else
      print "<seq not initialized>"  
    end    
    print "\n"
  end
  
  def show_loc()
    print "chr", @chr, "\t", @start, "\t", @stop, "\t", @id, "\t"+"0"+"\t", @strand, "\n"    
  end
  
  # TEST methods
  def SeqRegion.test_constructor()
    chr = "X"
    start = 200
    stop = 500

    peak_loc = 300
    strand = "-"
    seq = "AAAAATTTTT"
    score = 10
    args = {'id' => "dummy_id", 'chr' => "X", 'start' => 10, 'stop' => 20, 'peak_location' => 15, 'strand' => "+", 'seq' => nil, 'score' => 0.0}
    r = SeqRegion.new(args)
#    r = SeqRegion.new(chr, start, stop, peak_loc, strand, seq, score)
# #   (id = "dummy_id", chr = "X", start = 10, stop = 20, peak_location = 15, strand = "+", seq = nil, score = 0.0)            
    r.show()
    gets
  end
    
  def SeqRegion.test_sort()
    id = "label11"; chr = "1"; start =  55; stop =  200; peak_location = 100; strand = "+"; seq = nil; score = 102
    args = {'id' => id, 'chr' => chr, 'start' => start, 'stop' => stop, 'peak_location' => peak_location, 'strand' => strand, 'seq' => nil, 'score' => score}
    r1 = SeqRegion.new(args)
    
    id = "label22";chr = "Y";start = 555;stop = 1111;peak_location = 800;strand = "-"; seq = nil; score = 3
    args = {'id' => id, 'chr' => chr, 'start' => start, 'stop' => stop, 'peak_location' => peak_location, 'strand' => strand, 'seq' => nil, 'score' => score}
    r2 = SeqRegion.new(args)
    
    id = "label33";chr = "X";start = 35;stop = 345;peak_location = 150;strand = "-"; seq = nil; score= 10
    args = {'id' => id, 'chr' => chr, 'start' => start, 'stop' => stop, 'peak_location' => peak_location, 'strand' => strand, 'seq' => nil, 'score' => score}
    r3 = SeqRegion.new(args)
   
    arr = [r2,r1,r3]
    arr.sort{|a,b| a.start <=> b.start}.each do |r|
      r.show()
    end  
    print "\n"
    r2.seq = "AAATGTGGTGGT"
    arr.sort{|a,b| a.score <=> b.score}.each do |r|
      r.show()
    end
    print "\n"
    arr.sort{|a,b| a.compare_loc(b)}.each do |r|
      r.show()
    end
  end


  def SeqRegion.generate_cERMIT_input_from_expression_centroids(in_centroids_file, in_expression_file)
    centroid_lines = IO.readlines(in_centroids_file)
    expr_lines     = IO.readlines(in_expression_file)
    gene_corr_scores = {}
    centroid_lines[1..-1].each do |l_centr|
      arr_centr = l_centr.strip.split("\s")
      print "arr_centr:", arr_centr.inspect
      gets
      expr_lines[1..-1].each do |l_expr|
        arr_expr = l_expr.strip.split("\s")
        gene_id = x[0]
        print gene_id,"\t", arr_expr[1..-1].inspect
        gets
        gene_corr_scores[gene_id] = BasicStats.PearsonCorr(arr_centr[1..-1],arr_expr[1..-1])
      end
    end
    return gene_corr_scores
  end
  
private 

  def rev_complement_proc(seq)
    seq.split("").collect { |el|
      case el
        when "A"; el = "T"
        when "a"; el = "t"
        when "T"; el = "A"
        when "t"; el = "a"
        when "G"; el = "C"
        when "g"; el = "c"
        when "C"; el = "G"
        when "c"; el = "g"
        else el = el
      end
    }.join("").reverse
  end

# end of class
end
#SeqRegion.test_constructor()
#SeqRegion.test_sort()
#load("/home/sgg4/ruby_ws/gene_sets/SeqRegion.rb")
